﻿local QHisFirst = true
local lastList
local L = QN_Locale
local RGBStr = {
               R = "|CFFFF0000",
               G = "|CFF00FF00",
               B = "|CFF0000FF",
               Y = "|CFFFFFF00",
               K = "|CFF00FFFF",
               D = "|C0000AAFF",
               P = "|CFFD74DE1"
                }

local function UpdateChk()
  QNOchk_Switch:SetChecked(QN_Settings.Switch)
  if QN_Settings.Switch == true then
    QNOchk_Raid:Enable();
    QNOchk_Party:Enable();
    QNOchk_Solo:Enable();
    QNOchk_Sound:Enable();
    QNOchk_Debug:Enable();
    QNOchk_NoDetail:Enable();
	QNOchk_CompleteX:Enable();
  else
    QNOchk_Raid:Disable();
    QNOchk_Party:Disable();
    QNOchk_Solo:Disable();
    QNOchk_Sound:Disable();
    QNOchk_Debug:Disable();
    QNOchk_NoDetail:Disable();
	QNOchk_CompleteX:Disable();
  end

  QNOchk_Raid:SetChecked(QN_Settings.Raid)
  QNOchk_Party:SetChecked(QN_Settings.Party)
  QNOchk_Solo:SetChecked(QN_Settings.Solo)
  QNOchk_Sound:SetChecked(QN_Settings.Sound)
  QNOchk_Debug:SetChecked(QN_Settings.Debug)
  QNOchk_NoDetail:SetChecked(QN_Settings.NoDetail)
  QNOchk_CompleteX:SetChecked(QN_Settings.CompleteX)
end

local function RScanQuests()
  local QuestList = {}
  local qIndex = 1
  local qLink
  local splitdot = L["Colon"]           -- zh_CN 为全角" ：" ,en_US 为半角的 ":" ,zh_TW 请自行试验
  while GetQuestLogTitle(qIndex) do
   local qTitle, qLevel, qTag, qGroup, qisHeader, qisCollapsed, qisComplete, qisDaily, qID = GetQuestLogTitle(qIndex)
   if not qisHeader then
     --local qbutton = QuestLogScrollFrame.buttons[qIndex]
     --local prehead = "["..qLevel.."]"
     --print(qbutton:GetText())
     --qbutton:SetText(prehead..qTitle)
     --QuestLogControlPanel_UpdateState()
     qLink = GetQuestLink(qIndex)
     QuestList[qID]={
        Title    =qTitle,       -- String
        Level    =qLevel,       -- Integer
        Tag      =qTag,         -- String
        Group    =qGroup,       -- Integer
        Header   =qisHeader,    -- boolean
        Collapsed=qisCollapsed, -- boolean
        Complete =qisComplete,  -- Integer
        Daily    =qisDaily,     -- Integer
        QuestID  =qID,          -- Integer
        Link     =qLink
     }
     if qisComplete == 1 and ( IsQuestWatched(qIndex) ) and QN_Settings.CompleteX == true then
	   RemoveQuestWatch(qIndex)
       WatchFrame_Update()
     end
     for i=1,GetNumQuestLeaderBoards(qIndex) do
        local leaderboardTxt, itemType, isDone = GetQuestLogLeaderBoard (i,qIndex);
        local j, k, itemName, numItems, numNeeded = string.find(leaderboardTxt, "(.*)"..splitdot.."%s*([%d]+)%s*/%s*([%d]+)");
        -- print(qID,qTitle,qLevel,qTag,qGroup,qisHeader,qisCollapsed,qisComplete,qisDaily,leaderboardTxt,itemType,isDone,j,k,itemName,numItems,numNeeded)
        QuestList[qID][i]={
                        NeedItem =itemName,             -- String
                        NeedNum  = numNeeded,            -- Integer
                        DoneNum  = numItems             -- Integer
                        }
     end
   end

   qIndex = qIndex + 1
  end
  return QuestList
end

local function PrtChatMsg(msg)
  if UnitInRaid("player") then
    if QN_Settings.Raid == true then
      SendChatMessage(msg, "raid", nil)
    end
  elseif UnitInParty("Party1") then
    if QN_Settings.Party == true then
      SendChatMessage(msg, "party", nil)
    end
  else
    if QN_Settings.Solo == true then
      SendChatMessage(msg, "say", nil)
    end
  end
end

local function DebugMsg(msg)
  DEFAULT_CHAT_FRAME:AddMessage(msg)
end

--hooksecurefunc("QuestLog_Update",function()
function QN_OnEvent(event)
  --print(event)
  if event ==  "VARIABLES_LOADED" then
    if not QN_Settings then
      QN_Settings = {
                    Switch = true,
                    Raid = true,
                    Party = true,
                    Solo = false,
                    Sound = false,
                    Debug = true,
                    NoDetail = true,
					CompleteX = true
                   }
    end

    QuestNotifierOptionFrame:RegisterEvent("QUEST_LOG_UPDATE")
    UpdateChk()
  end

  if QN_Settings.Switch == false then
    return;
  end

  if event == "QUEST_LOG_UPDATE" then
  local QN_Progress = L["Progress"]
  local QN_ItemMsg,QN_ItemColorMsg = " "," "

  if QHisFirst then
    lastList = RScanQuests()
    QHisFirst = false
  end

  local currList = RScanQuests()

  for i,v in pairs(currList) do
    local TagStr = " ";
    if currList[i].Tag and (currList[i].Group < 2) then TagStr = RGBStr.Y .. "["..currList[i].Tag.."]|r" end
    if currList[i].Tag and (currList[i].Group > 1) then TagStr = RGBStr.Y .. "["..currList[i].Tag..currList[i].Group.."]|r" end
    if currList[i].Daily == 1 and currList[i].Tag then
      TagStr = RGBStr.D .. "[" .. DAILY .. currList[i].Tag .. "]|r" ;
      --print(TagStr)
    elseif currList[i].Daily == 1 then
      TagStr = RGBStr.D .. "[" .. DAILY .. "]|r";
    elseif currList[i].Tag then
      TagStr = "["..currList[i].Tag .. "]";
    end
    --print(TagStr)
    if lastList[i] then  -- 已有任务，上次和本次Scan都有这一个任务

      if not lastList[i].Complete then
        if (#currList[i] > 0) and (#lastList[i] > 0) then
          for j=1,#currList[i] do
            if currList[i][j].DoneNum and lastList[i][j].DoneNum then
              if currList[i][j].DoneNum > lastList[i][j].DoneNum then
                --QN_ItemMsg = L["Quest"]..currList[i].Link..QN_Progress ..": ".. currList[i][j].NeedItem ..":".. currList[i][j].DoneNum .. "/"..currList[i][j].NeedNum
                QN_ItemMsg = QN_Progress ..":" .. currList[i][j].NeedItem ..": ".. currList[i][j].DoneNum .. "/"..currList[i][j].NeedNum
                QN_ItemColorMsg = L["QN_Short"] .. RGBStr.G..L["Quest"].."|r".. RGBStr.P .. "["..currList[i].Level.."]|r "..currList[i].Link..RGBStr.G..QN_Progress..":|r"..RGBStr.K..currList[i][j].NeedItem..":|r"..RGBStr.Y..currList[i][j].DoneNum .. "/"..currList[i][j].NeedNum .."|r"
                if QN_Settings.NoDetail == false then
                  PrtChatMsg(QN_ItemMsg)
                end
                if not (UnitInRaid("player") or UnitInParty("Party1")) then
                  if QN_Settings.Debug == true then
                    DebugMsg(QN_ItemColorMsg)
                  end
                end
              end
            end
          end
        end
      end

      if (#currList[i] > 0) and (#lastList[i] > 0) and (currList[i].Complete == 1) then
        if not lastList[i].Complete then
          if (currList[i].Group > 1) and currList[i].Tag then
            QN_ItemMsg = L["Quest"].."["..currList[i].Level.."]".."["..currList[i].Tag..currList[i].Group.."]"..currList[i].Link.." "..L["Complete"]
          else
          QN_ItemMsg = L["Quest"].."["..currList[i].Level.."]"..currList[i].Link.." "..L["Complete"]
          end
          QN_ItemColorMsg = L["QN_Short"] .. RGBStr.G .. L["Quest"] .. "|r" .. RGBStr.P .. "[" .. currList[i].Level .. "]|r " .. currList[i].Link .. TagStr .. RGBStr.K .. L["Complete"] .. "|r"
          PrtChatMsg(QN_ItemMsg)
          if not ( UnitInRaid("player") or UnitInParty("Party1") ) then
            if QN_Settings.Debug == true then
             DebugMsg(QN_ItemColorMsg)
            end
          end
          if QN_Settings.Sound == true then
            PlaySoundFile("Interface\\AddOns\\QuestNotifier\\QuestComplete.ogg", "Master")
          end
          UIErrorsFrame:AddMessage(QN_ItemColorMsg);
        end
      end
    end

    if not lastList[i] then  -- last List have not the Quest, New Quest Accepted
      if (currList[i].Group > 1) and currList[i].Tag then
        QN_ItemMsg = L["Accept"]..":["..currList[i].Level.."]".."["..currList[i].Tag..currList[i].Group.."]"..currList[i].Link
      elseif currList[i].Daily == 1 then
        QN_ItemMsg = L["Accept"]..":["..currList[i].Level.."]".."[" .. DAILY .. "]"..currList[i].Link
      else
        QN_ItemMsg = L["Accept"]..":["..currList[i].Level.."]"..currList[i].Link
      end
      --print(TagStr)
      QN_ItemColorMsg = L["QN_Short"]..RGBStr.K .. L["Accept"]..":|r" .. RGBStr.P .."["..currList[i].Level.."]|r "..TagStr..currList[i].Link
      PrtChatMsg(QN_ItemMsg)
      --print(QN_ItemMsg)
      if not (UnitInRaid("player") or UnitInParty("Party1")) then
        if QN_Settings.Debug == true then
          DebugMsg(QN_ItemColorMsg)
        end
      end
    end

  end

  lastList = currList
  end
  --print("======================")
end

local function TypeCheck(var, vType, default)
  if type(var) ~= vType then
    return default;
  else
    return var;
  end
end

local function StrSplit(str, separator, trim)
  if not TypeCheck(separator, "string") or separator == "" then
     separator = " ";
  end
  local regEx = "([^" .. separator .. "]*)" .. separator .. "?";
  local strArray = {};
  if TypeCheck(str, "string") and str ~= "" then
    local i;
    for i in string.gmatch(str .. separator, regEx) do
      local s = i;
      if trim then
        s = string.gsub(s, "^%s*(.-)%s*$", "%1");
        if s == "" then
          s = nil;
        end
      end
      if s then
        table.insert(strArray, s);
      end
    end
  end
  return strArray, table.getn(strArray);
end

local function listcommand()
   DEFAULT_CHAT_FRAME:AddMessage(L["QN_LoadStr"]);
   DEFAULT_CHAT_FRAME:AddMessage(L["QN_cmdLine1"]);
   DEFAULT_CHAT_FRAME:AddMessage(L["QN_cmdLine2"]);
   DEFAULT_CHAT_FRAME:AddMessage(L["QN_cmdLine3"]);
   DEFAULT_CHAT_FRAME:AddMessage(L["QN_cmdLine4"]);
   DEFAULT_CHAT_FRAME:AddMessage(L["QN_cmdLine5"]);
   DEFAULT_CHAT_FRAME:AddMessage(L["QN_cmdLine6"]);
   DEFAULT_CHAT_FRAME:AddMessage(L["QN_cmdLine7"]);
end

local function booltostr(bval)
  local rstr = " "
  if bval == true then
    rstr = RGBStr.G .."on|r"
  end
  if bval == false then
    rstr = RGBStr.R .."off|r"
  end
  return rstr
end

local function cmdchange(mode)
  UpdateChk()
  if (mode == "on") or (mode == "off") then
    print(L["QN_Str"].. RGBStr.K.."Status: |r"..booltostr(QN_Settings.Switch))
  elseif mode =="raid" then
    print(L["QN_Str"].. RGBStr.K.. "Raid Mode: |r"..booltostr(QN_Settings.Raid))
  elseif mode =="party" then
    print(L["QN_Str"].. RGBStr.K.."Party Mode: |r"..booltostr(QN_Settings.Party))
  elseif mode =="solo" then
    print(L["QN_Str"].. RGBStr.K.."Solo Mode: |r"..booltostr(QN_Settings.Solo))
  elseif mode =="sound" then
    print(L["QN_Str"].. RGBStr.K.."Play Sound: |r"..booltostr(QN_Settings.Sound))
  elseif mode =="debug" then
    print(L["QN_Str"].. RGBStr.K.."Debug: |r"..booltostr(QN_Settings.Debug))
  end
end

local function prtstatus(mode)
  UpdateChk()
  print(L["QN_Str"].. RGBStr.K.."Status: |r"..booltostr(QN_Settings.Switch))
  print(L["QN_Str"].. RGBStr.K.. "Raid Mode: |r"..booltostr(QN_Settings.Raid))
  print(L["QN_Str"].. RGBStr.K.."Party Mode: |r"..booltostr(QN_Settings.Party))
  print(L["QN_Str"].. RGBStr.K.."Solo Mode: |r"..booltostr(QN_Settings.Solo))
  print(L["QN_Str"].. RGBStr.K.."Play Sound: |r"..booltostr(QN_Settings.Sound))
  print(L["QN_Str"].. RGBStr.K.."Debug: |r"..booltostr(QN_Settings.Debug))
end

local function SlashCommandHandler(line)
  --DEFAULT_CHAT_FRAME:AddMessage(line);
  local arr, count = StrSplit(line or "", " ", true);
  -- print(count);
  local cmd = string.lower(arr[1] or "");
  local arg = string.lower(arr[2] or "");
  arg = strtrim(arg);
  --print("Line:"..line,"CMD:"..cmd,"arg:"..arg,"count:"..count)
  if (count == 0) or (count > 1) then
    listcommand()
  end
  if count == 1 then
    if cmd == "on" then
      QN_Settings.Switch = true
    elseif cmd =="off" then
      QN_Settings.Switch =false
    elseif cmd == "raid" then
      QN_Settings.Raid = not(QN_Settings.Raid)
    elseif cmd == "party" then
      QN_Settings.Party = not(QN_Settings.Party)
    elseif cmd == "solo" then
      QN_Settings.Solo = not(QN_Settings.Solo)
    elseif cmd == "sound" then
      QN_Settings.Sound = not(QN_Settings.Sound)
    elseif cmd == "debug" then
      QN_Settings.Debug = not(QN_Settings.Debug)
    elseif cmd == "status" then
      prtstatus()
    elseif cmd == "set" then
      InterfaceOptionsFrame_OpenToCategory("QuestNotifier")
    elseif cmd == "inscd" then
      PrintInstances()
    else
      listcommand()
    end
    cmdchange(cmd)
  end
end

local function QuestLogScrollFrameMouseWheel(self,delta)
  HybridScrollFrame_OnMouseWheel(self, delta);
  QuestLog_Update();
end

local function QuestLogScrollFrameScrollBarChange(self,value)
  HybridScrollFrame_OnValueChanged(self:GetParent(), value);
  QuestLog_Update();
end

function QN_OPtionPrePanel(self)

   --self:RegisterEvent("PLAYER_ENTERING_WORLD")
   --self:RegisterEvent("QUEST_LOG_UPDATE")
   --self:RegisterEvent("ADDON_LOADED")
   self:RegisterEvent("VARIABLES_LOADED")
   QuestLogScrollFrameScrollBar:SetScript("OnValueChanged",QuestLogScrollFrameScrollBarChange)
   QuestLogScrollFrame:SetScript("OnMouseWheel",QuestLogScrollFrameMouseWheel)
   self.name = "QuestNotifier";
   InterfaceOptions_AddCategory(self);

   SLASH_QUESTNOTIFIER1 = "/questnotifier";
   SLASH_QUESTNOTIFIER2 = "/qn";
   SlashCmdList["QUESTNOTIFIER"] = function(msg) SlashCommandHandler(msg) end;
   --DEFAULT_CHAT_FRAME:AddMessage(L["QN_LoadStr"]);
end




local function _QuestLog_HighlightQuest(questLogTitle)
	local prevParent = QuestLogHighlightFrame:GetParent();
	if ( prevParent and prevParent ~= questLogTitle ) then
		-- set prev quest's colors back to normal
		local prevName = prevParent:GetName();
		prevParent:UnlockHighlight();
		prevParent.tag:SetTextColor(prevParent.r, prevParent.g, prevParent.b);
		prevParent.groupMates:SetTextColor(prevParent.r, prevParent.g, prevParent.b);
	end
	if ( questLogTitle ) then
		local name = questLogTitle:GetName();
		-- highlight the quest's colors
		questLogTitle.tag:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		questLogTitle.groupMates:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		questLogTitle:LockHighlight();
		-- reposition highlight frames
		QuestLogHighlightFrame:SetParent(questLogTitle);
		QuestLogHighlightFrame:SetPoint("TOPLEFT", questLogTitle, "TOPLEFT", 0, 0);
		QuestLogHighlightFrame:SetPoint("BOTTOMRIGHT", questLogTitle, "BOTTOMRIGHT", 0, 0);
		QuestLogSkillHighlight:SetVertexColor(questLogTitle.r, questLogTitle.g, questLogTitle.b);
		QuestLogHighlightFrame:Show();
	else
		QuestLogHighlightFrame:Hide();
	end
end

QuestLog_Update = function ()
 	if ( not QuestLogFrame:IsShown() ) then
		return;
	end

	local numEntries, numQuests = GetNumQuestLogEntries();
	if ( numEntries == 0 ) then
		HideUIPanel(QuestLogDetailFrame);
		QuestLogDetailFrame.timeLeft = nil;
		EmptyQuestLogFrame:Show();
		QuestLog_SetSelection(0);
	else
		EmptyQuestLogFrame:Hide();
	end

	QuestLog_UpdateMapButton();

	-- Update Quest Count
	QuestLog_UpdateQuestCount(numQuests);

	-- If no selection then set it to the first available quest
	local questLogSelection = GetQuestLogSelection();
	local haveSelection = questLogSelection ~= 0;
	if ( numQuests > 0 and not haveSelection ) then
		if ( QuestLogFrame.selectedIndex ) then
			QuestLog_SetNearestValidSelection();
		else
			QuestLog_SetFirstValidSelection();
		end
		questLogSelection = GetQuestLogSelection();
	end
	QuestLogFrame.selectedIndex = questLogSelection;

    --The counts may have changed with SetNearestValidSelection expanding quest headers.
    --Bug ID 170644
    numEntries, numQuests = GetNumQuestLogEntries();

	-- hide the details if we don't have a selected quest
	if ( not haveSelection ) then
		HideUIPanel(QuestLogDetailFrame);
	end

	-- update the group timer
	local haveGroup = GetNumPartyMembers() > 0 or GetNumRaidMembers() > 1;
	if ( haveGroup ) then
		QuestLogFrame.groupUpdateTimer = 0;
	else
		QuestLogFrame.groupUpdateTimer = nil;
	end

	-- hide the highlight frame initially, it may be shown when we loop through the quest listing if a quest is selected
	QuestLogHighlightFrame:Hide();

	-- Update the quest listing
	local buttons = QuestLogScrollFrame.buttons;
	local numButtons = #buttons;
	local scrollOffset = HybridScrollFrame_GetOffset(QuestLogScrollFrame);
	local buttonHeight = buttons[1]:GetHeight();
	local displayedHeight = 0;

	local numPartyMembers = GetNumPartyMembers();
	local questIndex, questLogTitle, questTitleTag, questNumGroupMates, questNormalText, questCheck;
	local title, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, questID, displayQuestID;
	local color;
	local partyMembersOnQuest, tempWidth, textWidth;
	for i=1, numButtons do
		questLogTitle = buttons[i];
		questIndex = i + scrollOffset;
		questLogTitle:SetID(questIndex);
		questTitleTag = questLogTitle.tag;
		questNumGroupMates = questLogTitle.groupMates;
		questCheck = questLogTitle.check;
		questNormalText = questLogTitle.normalText;
		if ( questIndex <= numEntries ) then
			title, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, questID, displayQuestID = GetQuestLogTitle(questIndex);

			if ( isHeader ) then
				-- set the title
				if ( title ) then
					questLogTitle:SetText(title);
				else
					questLogTitle:SetText("");
				end

				-- set the normal texture based on the header's collapsed state
				if ( isCollapsed ) then
					questLogTitle:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
				else
					questLogTitle:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up");
				end
				questLogTitle:SetHighlightTexture("Interface\\Buttons\\UI-PlusButton-Hilight");

				questNumGroupMates:Hide();
				questTitleTag:Hide();
				questCheck:Hide();
			else
				-- set the title

				LevelStr = "["..level.."] "
        if isDaily == 1 then
          LevelStr = RGBStr.D .. LevelStr .."|r"
        end
        if suggestedGroup >=2 then
          title = LevelStr .. RGBStr.P.. "[G"..suggestedGroup.."]|r"..title
        else
          title = LevelStr .. title;
        end
        questLogTitle:SetText("  "..title);

				--if ( ENABLE_COLORBLIND_MODE == "1" ) then
				--	title = "["..level.."] " .. title;
				--end

				if (questID and displayQuestID) then
					--questLogTitle:SetText("  "..questID.." - "..title);
				else
					questLogTitle:SetText("  "..title);
				end

				-- this isn't a header, hide the header textures
				questLogTitle:SetNormalTexture("");
				questLogTitle:SetHighlightTexture("");

				-- If not a header see if any nearby group mates are on this quest
				partyMembersOnQuest = 0;
				for j=1, numPartyMembers do
					if ( IsUnitOnQuest(questIndex, "party"..j) ) then
						partyMembersOnQuest = partyMembersOnQuest + 1;
					end
				end
				if ( partyMembersOnQuest > 0 ) then
				  partyMembersOnQuest = partyMembersOnQuest + 1;
					questNumGroupMates:SetText("["..partyMembersOnQuest.."]");
					questNumGroupMates:Show();
				else
					questNumGroupMates:Hide();
				end

				-- figure out which tag to show, if any
				if ( isComplete and isComplete < 0 ) then
					questTag = FAILED;
				elseif ( isComplete and isComplete > 0 ) then
					questTag = COMPLETE;
				elseif ( isDaily ) then
					if ( questTag ) then
            --questTag = format(DAILY_QUEST_TAG_TEMPLATE, questTag);
            if questTag == LFG_TYPE_DUNGEON then
              questTag = DAILY .. GMSURVEYRATING3;
            else
              questTag = format(DAILY_QUEST_TAG_TEMPLATE, questTag);
            end
          else
            questTag = DAILY ;
          end
				end
				if ( questTag ) then
					questTitleTag:SetText("("..questTag..")");
					questTitleTag:Show();
				else
					questTitleTag:Hide();
				end

				-- show the quest check if the quest is being watched
				if ( IsQuestWatched(questIndex) ) then
					questCheck:Show();
				else
					questCheck:Hide();
				end
			end

			-- Save if its a header or not
			questLogTitle.isHeader = isHeader;

			-- resize the title button so everything fits where it's supposed to
			QuestLogTitleButton_Resize(questLogTitle);

			-- Color the quest title and highlight according to the difficulty level
			if ( isHeader ) then
				color = QuestDifficultyColors["header"];
			else
				color = GetQuestDifficultyColor(level);
			end

			if isDaily == 1 then
        questTitleTag:SetText(RGBStr.D .. questTitleTag:GetText() .. "|r")
      end
      if isComplete and isComplete > 0 then
        questTitleTag:SetText("|cFFFF78FF("..COMPLETE..")|r");
      end

			questTitleTag:SetTextColor(color.r, color.g, color.b);
			questLogTitle:SetNormalFontObject(color.font);
			questNumGroupMates:SetTextColor(color.r, color.g, color.b);
			questLogTitle.r = color.r;
			questLogTitle.g = color.g;
			questLogTitle.b = color.b;
			questLogTitle:Show();

			-- Place the highlight and lock the highlight state
			if ( questLogSelection == questIndex ) then
				_QuestLog_HighlightQuest(questLogTitle);
			else
				questLogTitle:UnlockHighlight();
			end
		else
			questLogTitle:Hide();
		end
		displayedHeight = displayedHeight + buttonHeight;
	end
	HybridScrollFrame_Update(QuestLogScrollFrame, numEntries * buttonHeight, displayedHeight);

	-- update the control panel
	QuestLogControlPanel_UpdateState();

	--QuestLogQuestCount:SetPoint("TOPLEFT", "QuestLogCountTopLeft", 0, 0)---4

 -- QuestLogDailyQuestCount:SetPoint("TOPLEFT", "QuestLogQuestCount", 0, 0-(QuestLogQuestCount:GetHeight()+2))

  if QuestLogDailyQuestCount:IsVisible() then
    local dailycstr = format(QUEST_LOG_DAILY_COUNT_TEMPLATE, GetDailyQuestsCompleted(), GetMaxDailyQuests());
    QuestLogDailyQuestCount:SetText(RGBStr.D .. dailycstr .. "|r");
  end

end

function PrtIns()
  for index = 1,GetNumSavedInstances() do
   local name, id, reset, difficulty, locked, extended, instanceIDMostSig, isRaid, maxPlayers, difficultyName = GetSavedInstanceInfo(index)
   local dd,hh,mm,ss = 0,0,0,0
   local cdstr = " "
   if reset > 86400 then
      dd = floor( reset / 86400 )
      hh = floor((reset - dd * 86400) / 3600 )
      mm=floor((reset - dd * 86400 - hh * 3600) / 60 )
      ss = reset - dd * 86400 - hh * 3600 - mm * 60
   elseif reset >  3600 then
      hh = floor(reset / 3600)
      mm = floor( (reset - hh * 3600)  / 60 )
      ss = reset - hh * 3600 - mm * 60
   elseif reset >  60 then
      mm = floor(reset /60)
      ss = reset - mm * 60
   else
      ss = reset
   end
   if dd > 0 then
      cdstr = dd .."天"   --..hh.."小时"..mm.."分"..ss.."秒"
   elseif hh > 0 then
      cdstr = hh.."小时"  --..mm.."分"..ss.."秒"
   elseif mm > 0 then
      cdstr = mm.."分"    --..ss.."秒"
   else
      cdstr = ss.."秒"
   end

   local insmsg = name.." "..difficultyName.." "..cdstr
   if reset ~= 0 then
      if UnitIsPlayer("target") and  UnitIsFriend("target","player") then
        SendChatMessage(insmsg,"whisper",nil,UnitName("target"))
      elseif UnitInParty("Party1") then
        SendChatMessage(insmsg,"Party",nil)
      else
        SendChatMessage(insmsg,"Say",nil)
      end
   end
  end
--print(GetTime())
end

