﻿--[[


一些说明：

   Sora's AuraWatch对于Buff列表的管理是分组进行的,每一组Buff公用同一个定位点,同样的大小,同样的样式
   
   在组属性中
   {
		Name = 分组的名称
		Direction = 提示的增长方向 ("RIGHT"/"LEFT"/"UP"/"DOWN")
		Interval = 相邻提示的间距
		Mode = 提示模式(图标ICON 或者 计时条BAR)
		IconSize = 图标大小
		BarWidth = 计时条宽度(BAR模式下必须有这个属性)
		Pos = 首图标的定位点
		List = 要监视的Buff/Debuff/CD列表	
   }
   
   其中List =
   {
		AuraID/ItemID/AuraID = 三选一,分别对应监视 Buff/Debuff,物品CD,技能CD 三种情况
		UnitID = 要监视的目标,常用的有 玩家"player"/目标"target" (如果要监视Buff/Debuff的话必须有)
		Caster = 过滤Buff/Debuff的释放者 (可选,如果不需要按照施法者过滤请不要写这一项 ！！！注意,C为大写！！！ )
		Stack = 过滤Buff/Debuff的层数(可选,当Buff/Debuff层数大于等于Stack的值的时候才显示 ！！！注意,S为大写！！！)
	}

	eg. 这是一个示例
	{
		Name = "TargetDebuff",
		Direction = "UP",
		Interval = 4,
		Mode = "BAR",
		IconSize = 16,
		BarWidth = 175,
		Pos = {"BOTTOM", "oUF_SoraTarget", "TOP", 8, 5},
		List = {
			-- 血之疫病
			{AuraID = 55078, UnitID = "target", Stack = 1},
			-- 冰霜疫病
			{AuraID = 55095, UnitID = "target", Caster = "player"},
			-- 不灭药水
			{ItemID = 40093},
		},
	},

]]
----------------
--  命名空间  --
----------------

local _, SR = ...
local cfg = SR.AuraWatchConfig

SRAuraList = {

	-- 全职业
--[[	["ALL"] = {
		{
			Name = "Player_Buff_Icon",
			Direction = "RIGHT",
			Interval = 4,
			Mode = "ICON",
			IconSize = 54,
			Pos = {"CENTER", UIParent, "CENTER", -200, 200},
			List = {
				--光明之泉恢复
				{AuraID =  7001, UnitID = "player"},				
				--希望圣歌(提高法力值上限)
				{AuraID =  64904, UnitID = "player"},				
				--愈合祷言
				{AuraID =  33076, UnitID = "player"},				
				--守护圣灵
				{AuraID =  47788, UnitID = "player"},				
				--痛苦压制
				{AuraID =  33206, UnitID = "player"},				
				--真言术：盾
				{AuraID =  17, UnitID = "player"},				
				--恢复(Hot)
				{AuraID =  139, UnitID = "player"},			
				--防恐结界
				{AuraID =  6346, UnitID = "player"},				
				--灵魂之力(勇气SP)
				{AuraID =  91019, UnitID = "player"},
				--剧毒折磨(ZG毒锅)
				{AuraID =  96328, UnitID = "player"},
				--心灵之歌(治疗主手FM)
				{AuraID =  74224, UnitID = "player"},
				--火山毁灭 SP暗月卡片：火山
				{AuraID =  89091, UnitID = "player"},
				--亮纹刺绣
				{AuraID =  75170, UnitID = "player"},
				--飓风(主手武器FM)
				{AuraID =  74211, UnitID = "player"},
				--能量灌注
				{AuraID =  10060, UnitID = "player"},
				--嗜血
				{AuraID =  2825, UnitID = "player"},
				--英勇气概
				{AuraID = 32182, UnitID = "player"},
				--时间扭曲
				{AuraID = 80353, UnitID = "player"},
				--真言术:障
				{AuraID = 81782, UnitID = "player"},
			},
		},
	},
	]]
	--德鲁伊
	["DRUID"] = {
		{	--左边自身的Buff
			Name = "Player_Buff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 50},
			List = {
				--放缓流沙
				{AuraID =  109842, UnitID = "player"},
				--至高能量
				{AuraID =  107948, UnitID = "player"},
				--战斗意念
				{AuraID =  109793, UnitID = "player"},
				--生命之血
				{AuraID =  74497, UnitID = "player"},
				--火焰精粹
				{AuraID =  97008, UnitID = "player"},
				--相生
				{AuraID =  100977, UnitID = "player"},
				--炽炎之能
				{AuraID =  99461, UnitID = "player"},
				--生命之焰
				{AuraID =  99263, UnitID = "player"},
				--烈焰之翼
				{AuraID =  98619, UnitID = "player"},
				--生命之树
				{AuraID =  33891, UnitID = "player"},
				--火山毁灭 SP暗月卡片：火山
				{AuraID =  89091, UnitID = "player"},
				--清晰预兆
				{AuraID = 16864, UnitID = "player", Caster = "player"},
				--生存本能
				{AuraID = 61336, UnitID = "player", Caster = "player"},
				--激活
				{AuraID = 29166, UnitID = "player", Caster = "player"},
				--树皮
				{AuraID = 22812, UnitID = "player", Caster = "player"},
				--激怒
				{AuraID = 5229, UnitID = "player", Caster = "player"},
				--狂暴回复
				{AuraID = 22842, UnitID = "player", Caster = "player"},
				--自然之握
				{AuraID = 16689, UnitID = "player", Caster = "player"},
				--自然迅捷
				{AuraID = 17116, UnitID = "player", Caster = "all"},
				--宁静
				{AuraID = 740, UnitID = "player", Caster = "all"},
				--上古狂乱
				{AuraID = 90355, UnitID = "player", Caster = "all"},
				--嗜血
				{AuraID =  2825, UnitID = "player"},
				--英勇气概
				{AuraID = 32182, UnitID = "player"},
				--节能施法
				{AuraID = 16870, UnitID = "player"},
				--自然之赐
				{AuraID = 16886, UnitID = "player"},
				--日蚀
				{AuraID = 48517, UnitID = "player"},			
				--月蚀
				{AuraID = 48518, UnitID = "player"},
				--狂暴(猫&熊)
				{AuraID = 50334, UnitID = "player"},
				--野蛮咆哮(猫)
				{AuraID = 52610, UnitID = "player"},
				--时间扭曲
				{AuraID = 80353, UnitID = "player"},
				--粉碎
				{AuraID = 80951, UnitID = "player"},
				--月光淋漓
				{AuraID = 81192, UnitID = "player"},
				--坠星
				{AuraID = 93400, UnitID = "player"},
				--狂暴
				{AuraID = 93622, UnitID = "player"},
				--生命绽放
				{AuraID = 33763, UnitID = "player", Caster = "player"},
				--回春
				{AuraID = 774, UnitID = "player", Caster = "player"},
				--愈合
				{AuraID = 8936, UnitID = "player", Caster = "player"},			
				--野性成长
				{AuraID = 48438, UnitID = "player", Caster = "player"},
				--掠食者的迅捷
				{AuraID = 69369, UnitID = "player", Caster = "player"},
			},
		},

		{	--左边自身的Debuff
			Name = "Player_Debuff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 90},
			List = {
				--变羊
				{AuraID =   118, UnitID = "player"},
				--制裁之锤
				{AuraID =   853, UnitID = "player"},
				--肾击
				{AuraID =   408, UnitID = "player"},
				--撕扯
				{AuraID = 47481, UnitID = "player"},
				--沉默
				{AuraID = 55021, UnitID = "player"},
				--割碎
				{AuraID = 22570, UnitID = "player"},
				--断筋
				{AuraID =  1715, UnitID = "player"},
				--减速药膏
				{AuraID =  3775, UnitID = "player"},
			},
		},

		{   --右边目标的Buff
			Name = "Target_Debuff_Icon",
			Direction = "RIGHT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = { "center", nil, "center", 135, 50 },
			List = {
				--生命绽放
				{AuraID = 33763, UnitID = "target", Caster = "player"},
				--回春术
				{AuraID = 774, UnitID = "target", Caster = "player"},
				--愈合
				{AuraID = 8936, UnitID = "target", Caster = "player"},			
				--野性成长
				{AuraID = 48438, UnitID = "target", Caster = "player"},			
			},
		},		

		{	--右边目标的Debuff
			Name = "TargetDebuff",
			Direction = "RIGHT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", 135, 90},
			List = {	
				--月火
				--{AuraID = 8921, UnitID = "target", Caster = "player"},	
				--狂暴
				{AuraID = 50334, UnitID = "target", Caster = "player"},
				--猛击
				{AuraID = 5211, UnitID = "target", Caster = "player"},
				--虫群
				--{AuraID = 5570, UnitID = "target", Caster = "player"},
				--纠缠根须
				{AuraID = 339, UnitID = "target", Caster = "all"},
				--旋风
				{AuraID = 33786, UnitID = "target", Caster = "all"},
				--割碎
				{AuraID = 22570, UnitID = "target", Caster = "player"},
				--割伤
				{AuraID = 33745, UnitID = "target", Caster = "player"},
				--裂伤豹
				{AuraID = 33876, UnitID = "target", Caster = "player"},
				--裂伤熊
				{AuraID = 33878, UnitID = "target", Caster = "player"},
				--挫志咆哮
				{AuraID = 99, UnitID = "target", Caster = "player"},
				--斜掠
				--{AuraID = 1822, UnitID = "target", Caster = "player"},
				--割裂
				--{AuraID = 1079, UnitID = "target", Caster = "player"},
				--精灵之火
				{AuraID = 770, UnitID = "target", Caster = "player"},
				--精灵之火(野性)
				{AuraID = 16857, UnitID = "target", Caster = "player"},
				--感染伤口
				{AuraID = 58180, UnitID = "target", Caster = "player"},
				--野蛮咆哮(猫)
				{AuraID = 52610, UnitID = "target"},
				--阳炎术
				--{AuraID = 93402, UnitID = "target"},
			},
		},
				
		{	--右边目标的条形debuff计时
			Name = "Target_Debuff_Bar",
			Direction = "UP",
			Interval = 8,
			Mode = "bar",
			IconSize = 30,
			BarWidth = 175,
			Pos = {"LEFT", UIParent, "CENTER", 150, 150},
			List = {
				--月火术
				{AuraID =   8921, UnitID = "target", Caster = "player"},
				--虫群
				{AuraID =  5570, UnitID = "target", Caster = "player"},
				--阳炎术
				{AuraID =  93402, UnitID = "target", Caster = "player"},
				--斜掠
				{AuraID =  1822, UnitID = "target", Caster = "player"},
				--割裂
				{AuraID =  1079, UnitID = "target", Caster = "player"},
			},
		},
		
		{   --焦点的条形计时
			Name = "FocusDebuff",
			Direction = "UP",
			Interval = 8,
			Mode = "BAR",
			IconSize = 26,
			BarWidth = 175 ,
			Pos = {"CENTER", UIParent, "CENTER", -116, 250},
			List = {
				--休眠
				{AuraID =  2637 ,UnitID = "focus", Caster = "player"},
				--纠缠根须
				{AuraID =  339 ,UnitID = "focus", Caster = "player"},
			},
		},
	},
	
	--猎人
	["HUNTER"] = {
		{	--左边自身的Buff
			Name = "Player_Buff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 50},
			List = {
				--雄鹰守护
				{AuraID =  13165, UnitID = "player"},
				--灵狐守护
				{AuraID =  82661, UnitID = "player"},
				--猎豹守护
				{AuraID =  5118, UnitID = "player"},
				--豹群守护
				{AuraID =  13159, UnitID = "player"},
				--野性守护
				{AuraID =  20043, UnitID = "player"},
				--土拨鼠瞄准镜
				{AuraID =  99621, UnitID = "player"},
				--血性大发
				{AuraID =  94007, UnitID = "player"},
				--假死
				{AuraID =  5384, UnitID = "player"},
				--陷阱发射器
				{AuraID =  77769, UnitID = "player"},
				--炽炎之能
				{AuraID =  99461, UnitID = "player"},
				--烈焰之翼
				{AuraID =  98619, UnitID = "player"},
				--豹群/Aspekt des Rudels
				{AuraID = 13159,UnitID = "player"},
				--猎豹
				{AuraID = 5118, UnitID = "player"},
				--荷枪实弹
				{AuraID = 56453, UnitID = "player", Caster = "player"},
				--野性呼唤
				{AuraID = 53434, UnitID = "player", Caster = "player"},
				--集中火力
				{AuraID = 82692, UnitID = "player", Caster = "player"},
				--战术大师
				{AuraID = 34837, UnitID = "player", Caster = "player"},
				--强化稳固射击
				{AuraID = 53224, UnitID = "player", Caster = "player"},
				--嗜血
				{AuraID = 2825, UnitID = "player"},
				--英勇
				{AuraID = 32182, UnitID = "player"},
				--时间扭曲
				{AuraID = 80353, UnitID = "player"},
				--上古狂乱
				{AuraID = 90355, UnitID = "player"},
				--误导
				{AuraID = 34477, UnitID = "player"},
				--误导
				{AuraID = 35079, UnitID = "player"},
				--小红人
				{AuraID = 34471, UnitID = "player"},
				--强化稳固
				{AuraID = 53220, UnitID = "player"},
				--开火
				{AuraID = 82926, UnitID = "player"},
				--眼镜蛇打击
				{AuraID = 53257, UnitID = "player"},
				--血性大发
				{AuraID = 82749, UnitID = "player"},
				--阻击训练
				{AuraID = 64420, UnitID = "player"},
				--主人的召唤
				{AuraID = 54216, UnitID = "player"},
				--伪装
				{AuraID = 51755, UnitID = "player"},
				--威慑
				{AuraID = 19263, UnitID = "player"},
				--勇气咆哮
				{AuraID = 93435, UnitID = "player"},
				--上！
				{AuraID = 89388, UnitID = "player"},
			},
		},

		{	--左边自身的Debuff
			Name = "Player_Debuff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 90},
			List = {
				--变羊
				{AuraID =   118, UnitID = "player"},
				--制裁之锤
				{AuraID =   853, UnitID = "player"},
				--肾击
				{AuraID =   408, UnitID = "player"},
				--撕扯
				{AuraID = 47481, UnitID = "player"},
				--沉默
				{AuraID = 55021, UnitID = "player"},
				--割碎
				{AuraID = 22570, UnitID = "player"},
				--断筋
			   {AuraID =   1715, UnitID = "player"},
				--减速药膏
			   {AuraID =   3775, UnitID = "player"},
			},
		},

		{   --右边目标的Debuff
			Name = "Target_Debuff_Icon",
			Direction = "RIGHT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = { "CENTER", nil, "CENTER", 134, 50 },
			List = {	
				--摔绊
				{AuraID = 2974, UnitID = "target", Caster = "player"},
				--死亡标记
				{AuraID = 88691, UnitID = "target", Caster = "player"},
				--毒蛇钉刺
				--{AuraID = 1978, UnitID = "target", Caster = "player"},
				--蜘蛛毒刺
				{AuraID = 82654, UnitID = "target", Caster = "player"},
				--沉默射击/Unterdrückender Schuss
				{AuraID = 34490, UnitID = "target", Caster = "player"},
				--毒蝎钉刺/Skorpidstich
				{AuraID = 18545, UnitID = "target", Caster = "player"},
				--黑箭/Schwarzer Pfeil
				{AuraID = 3674, UnitID = "target", Caster = "player"},
				--爆炸射击/Explosivschuss
				{AuraID = 53301, UnitID = "target", Caster = "player"},
				--闪电吐息(风蛇的)
				{AuraID = 24844, UnitID = "target", Caster = "player"},
				--猎人印记/Mal des J?gers
				{AuraID = 1130, UnitID = "target"},
				--穿刺射击
				{AuraID = 63468, UnitID = "target", Caster = "player"},
				--冲击弹幕
				{AuraID = 35101, UnitID = "target", Caster = "player"},
				--眩晕
				{AuraID = 5116, UnitID = "target", Caster = "player"},
				--扰乱射击
				{AuraID = 20736, UnitID = "target", Caster = "player"},
			},
		},
		
		{	--右边目标的条形debuff计时
			Name = "Target_Debuff_Bar",
			Direction = "UP",
			Interval = 8,
			Mode = "bar",
			IconSize = 30,
			BarWidth = 175,
			Pos = {"LEFT", UIParent, "CENTER", 150, 150},
			List = {
				--毒蛇钉刺
				{AuraID = 1978, UnitID = "target", Caster = "player"},
				--痛苦无常
				{AuraID = 30108, UnitID = "target", Caster = "player"},
				--末日灾祸
				{AuraID =   603, UnitID = "target", Caster = "player"},
				--献祭
				{AuraID =  348, UnitID = "target", Caster = "player"},
				--腐蚀术
				{AuraID = 172, UnitID = "target", Caster = "player"},
				--恐惧
				{AuraID = 5782, UnitID = "target"},
				--放逐术
				{AuraID = 710, UnitID = "target"},
			},
		},
		
		{   --焦点的条形计时
			Name = "FocusDebuff",
			Direction = "UP",
			Interval = 8,
			Mode = "BAR",
			IconSize = 26,
			BarWidth = 175 ,
			Pos = {"CENTER", UIParent, "CENTER", -116, 250},
			List = {
				--翼龙钉刺
				{AuraID =  19386 ,UnitID = "focus", Caster = "player"},
				--沉默射击
				{AuraID =  34490 ,UnitID = "focus", Caster = "player"},
				--驱散射击
				{AuraID = 19503 ,UnitID = "focus", Caster = "player"},
			},
		},
	},
	
	--法师
	["MAGE"] = {
		{	--左边自身的Buff
			Name = "Player_Buff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 50},
			List = {
				--放缓流沙
				{AuraID =  109842, UnitID = "player"},
				--至高能量
				{AuraID =  107948, UnitID = "player"},
				--战斗意念
				{AuraID =  109793, UnitID = "player"},
				--窃取时间
				{AuraID =  105785, UnitID = "player"},
				--纵火
				{AuraID =  83582, UnitID = "player"},
				--炽炎之能
				{AuraID =  99461, UnitID = "player"},
				--烈焰之翼
				{AuraID =  98619, UnitID = "player"},
				--嗜血
				{AuraID =  2825, UnitID = "player"},
				--英勇气概
				{AuraID = 32182, UnitID = "player"},
				--上古狂乱
				{AuraID = 90355, UnitID = "player"},
				--奥术强化
				{AuraID = 12042, UnitID = "player", Caster = "player"},
				--唤醒
				{AuraID = 12051, UnitID = "player"},
				--奥术冲击
				{AuraID = 36032, UnitID = "player", Caster = "player"},				
				--寒冰指
				{AuraID = 44544, UnitID = "player"},
				--法术连击
				{AuraID = 48108, UnitID = "player"},
				--冰冷智慧
				{AuraID = 57761, UnitID = "player"},
				--冲击
				{AuraID = 64343, UnitID = "player"},
				--奥术飞弹!
				{AuraID = 79683, UnitID = "player"},
				--时间扭曲
				{AuraID = 80353, UnitID = "player"},
				--灸灼
				{AuraID = 87023, UnitID = "player"},
				--强化法术连击
				{AuraID = 44448, UnitID = "player"},
				--节能施法
				{AuraID = 12536, UnitID = "player"},
				--冲击
				{AuraID = 12358, UnitID = "player"},
				--激活
				{AuraID = 29166, UnitID = "player"},
				--拯救之手
				{AuraID = 1038, UnitID = "player"},
				--冰冷血脉
				{AuraID = 12472, UnitID = "player"},
				--寒冰护体
				{AuraID = 11426, UnitID = "player"},
				--气定
				{AuraID = 12043, UnitID = "player"},
				--魔法护盾
				{AuraID = 1463, UnitID = "player"},
				--冰箱
				{AuraID = 45438, UnitID = "player"},
				--隐身
				{AuraID = 32612, UnitID = "player"},
				--法师结界
				{AuraID = 543, UnitID = "player"},
			},
		},


		{	--左边自身的Debuff
			Name = "Player_Debuff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 90},
			List = {
				--变羊
				{AuraID =   118, UnitID = "player"},
				--制裁之锤
				{AuraID =   853, UnitID = "player"},
				--肾击
				{AuraID =   408, UnitID = "player"},
				--撕扯
				{AuraID = 47481, UnitID = "player"},
				--沉默
				{AuraID = 55021, UnitID = "player"},
				--割碎
				{AuraID = 22570, UnitID = "player"},
				--断筋
				{AuraID =  1715, UnitID = "player"},
				--减速药膏
				{AuraID =  3775, UnitID = "player"},
				--进化(黑石岩窟，柯尔拉·暮光之兆)
				{AuraID =  87378, UnitID = "player"},
				--暗影牢笼(黑石岩窟小怪，移动叠加伤害)
				{AuraID =  76686, UnitID = "player"},
				--寒冰炸弹(黑石岩窟小怪，每秒1000伤害降低35%移动速度)
				{AuraID =  76682, UnitID = "player"},
				--黑暗模拟
				{AuraID =  77606, UnitID = "player"},
			},
		},		

		{	--右边目标的Debuff
			Name = "Target_Debuff_Icon",
			Direction = "RIGHT",
			Interval = 4,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", 135, 90},
			List = {		
				--深度冻结
				{AuraID = 44572 ,UnitID = "target", Caster = "player"},
				--冰冻术
				{AuraID = 33395 ,UnitID = "target", Caster = "player"},
				--强化冰锥术
				{AuraID = 83301 ,UnitID = "target", Caster = "player"},
				--冲击
				{AuraID = 12357 ,UnitID = "target", Caster = "player"},
				--寒冰箭
				{AuraID = 116 ,UnitID = "target", Caster = "player"},
				--冰锥术
				{AuraID = 120 ,UnitID = "target", Caster = "player"},
				--冰霜新星
				{AuraID = 112 ,UnitID = "target", Caster = "player"},
				--霜火箭
				{AuraID = 44614 ,UnitID = "target", Caster = "player"},
				--反制
				{AuraID = 55021 ,UnitID = "target", Caster = "player"},
				--寒冰箭
				{AuraID = 116 ,UnitID = "target", Caster = "player"},
				--点燃
				{AuraID = 12654 ,UnitID = "target", Caster = "player"},
				--减速
				{AuraID = 31589 ,UnitID = "target", Caster = "player"},
				--活动炸弹
				{AuraID = 44457 ,UnitID = "target", Caster = "player"},
				--深冬之寒
				{AuraID = 28593 ,UnitID = "target", Caster = "player"},
				--羊
				{AuraID = 118 ,UnitID = "target", Caster = "player"},
				--临界炽焰  受到法术爆击的几率提高5%
				{AuraID = 22959 ,UnitID = "target", Caster = "player"},
			},
		},
		
		{   --焦点的条形计时
			Name = "TargetDebuff",
			Direction = "UP",
			Interval = 8,
			Mode = "BAR",
			IconSize = 26,
			BarWidth = 175 ,
			Pos = {"CENTER", UIParent, "CENTER", -116, 250},
			List = {
				--羊
				{AuraID =  118 ,UnitID = "focus", Caster = "player"},
				--减速
				{AuraID = 31589 ,UnitID = "target", Caster = "player"},
			},
		},
	},
	
	--战士
	["WARRIOR"] = {
		{	--左边目标的Buff
			Name = "Player_Buff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 50},
			List = {
				--炽炎之能
				{AuraID =  99461, UnitID = "player"},
				--烈焰之翼
				{AuraID =  98619, UnitID = "player"},
				--死亡之愿
				{AuraID =  12292, UnitID = "player"},
				--法术格挡
				{AuraID =  97954, UnitID = "player"},
				--集结呐喊
				{AuraID =  97463, UnitID = "player"},
				--鲁莽
				{AuraID =  1719, UnitID = "player"},
				--坚守阵地
				{AuraID =  84602, UnitID = "player"},
				--嗜血
				{AuraID =  2825, UnitID = "player"},
				--嗜血
				{AuraID =  2825, UnitID = "player"},
				--嗜血
				{AuraID =  2825, UnitID = "player"},
				--英勇气概
				{AuraID = 32182, UnitID = "player"},
				--盾墙(防御姿态)
				{AuraID =   871, UnitID = "player"},
				--怒火中烧
				{AuraID =  1134, UnitID = "player"},
				--盾牌格挡(防御姿态)
				{AuraID =  2565, UnitID = "player"},			
				--横扫攻击(战斗,狂暴姿态)
				{AuraID = 12328, UnitID = "player"},
				--战斗专注
				{AuraID = 12964, UnitID = "player"},
				--破釜沉舟
				{AuraID = 12975, UnitID = "player"},
				--血之狂热
				{AuraID = 16491, UnitID = "player"},
				--反击风暴(战斗姿态)
				{AuraID = 20230, UnitID = "player"},
				--嗜血
				{AuraID = 23885, UnitID = "player"},
				--法术发射(战斗,防御姿态)
				{AuraID = 23920, UnitID = "player"},
				--复苏之风
				{AuraID = 29841, UnitID = "player"},
				--胜利
				{AuraID = 32216, UnitID = "player"},
				--血脉喷张
				{AuraID = 46916, UnitID = "player"},
				--剑盾猛攻
				{AuraID = 50227, UnitID = "player"},
				--猝死
				{AuraID = 55694, UnitID = "player"},
				--激怒
				{AuraID = 57519, UnitID = "player"},
				--血之气息
				{AuraID = 60503, UnitID = "player"},
				--主宰
				{AuraID = 65156, UnitID = "player"},
				--时间扭曲
				{AuraID = 80353, UnitID = "player"},
				--胜利
				{AuraID = 82368, UnitID = "player"},
				--屠夫
				{AuraID = 84586, UnitID = "player"},
				--坚守阵地
				{AuraID = 84620, UnitID = "player"},
				--致命平静
				{AuraID = 85730, UnitID = "player"},
				--激动
				{AuraID = 86627, UnitID = "player"},
				--雷霆余震
				{AuraID = 87096, UnitID = "player"},
				--行刑者
				{AuraID = 90806, UnitID = "player"},
			},
		},	

		{	--左边自身的Debuff
			Name = "Player_Debuff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 90},
			List = {
				--变羊
				{AuraID =   118, UnitID = "player"},
				--制裁之锤
				{AuraID =   853, UnitID = "player"},
				--肾击
				{AuraID =   408, UnitID = "player"},
				--撕扯
				{AuraID = 47481, UnitID = "player"},
				--沉默
				{AuraID = 55021, UnitID = "player"},
				--割碎
				{AuraID = 22570, UnitID = "player"},
				--断筋
			   {AuraID =   1715, UnitID = "player"},
				--减速药膏
			   {AuraID =   3775, UnitID = "player"},
			},
		},

		{	--右边目标的Debuff
			Name = "Target_Debuff_Icon",
			Direction = "RIGHT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", 135, 50},
			List = {
				--击倒
				{AuraID = 85388, UnitID = "target", Caster = "player"},
				--震荡猛击
				{AuraID = 12809, UnitID = "target", Caster = "player"},
				--冲击波
				{AuraID = 46968, UnitID = "target", Caster = "player"},
				--禁令
				{AuraID = 12958, UnitID = "target", Caster = "player"},
				--巨人打击
				{AuraID = 86346, UnitID = "target", Caster = "player"},
				--重伤
				{AuraID = 12834, UnitID = "target", Caster = "player"},
				--断筋
				{AuraID = 1715, UnitID = "target", Caster = "player"},
				--破胆
				{AuraID = 5246, UnitID = "target", Caster = "player"},
				--眩晕
				{AuraID = 96273, UnitID = "target", Caster = "player"},
				--嘲讽
				{AuraID = 355, UnitID = "target", Caster = "player"},
				--挑战怒吼
				{AuraID = 1161, UnitID = "target", Caster = "player"},
				--撕裂(战斗,防御姿态)
				{AuraID = 94009, UnitID = "target", Caster = "player"},
				--断筋
				{AuraID = 1715, UnitID = "target", Caster = "player"},
				--破甲攻击
				{AuraID = 58567, UnitID = "target", Caster = "player"},
				--雷霆一击
				{AuraID = 6343, UnitID = "target", Caster = "player"},
				--挫志怒吼
				{AuraID = 1160, UnitID = "target", Caster = "player"},
			},
		},
	},
	
	--萨满
	["SHAMAN"] = {
		{	--左边自身的buff
			Name = "Player_Buff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 20},
			List = {
				--矩阵回稳
				{AuraID =  96979, UnitID = "player"},
				--时间断裂
				{AuraID =  105821, UnitID = "player"},
				--元素掌握
				{AuraID =  64701, UnitID = "player"},
				--先祖之怒
				{AuraID =  105779, UnitID = "player"},
				--节能施法
				{AuraID =  16246, UnitID = "player"},
				--放缓流沙
				{AuraID =  109842, UnitID = "player"},
				--至高能量
				{AuraID =  107948, UnitID = "player"},
				--战斗意念
				{AuraID =  109793, UnitID = "player"},
				--邪恶的馈赠
				{AuraID =  102662, UnitID = "player"},
				--能量洪流
				{AuraID =  74241, UnitID = "player"},
				--上古石化种子
				{AuraID =  97009, UnitID = "player"},
				--炽炎之能
				{AuraID =  99461, UnitID = "player"},
				--烈焰之翼
				{AuraID =  98619, UnitID = "player"},
				--生命之焰
				{AuraID =  99263, UnitID = "player"},
				--嗜血
				{AuraID =  2825, UnitID = "player"},
				--英勇气概
				{AuraID = 32182, UnitID = "player"},
				--时间扭曲
				{AuraID = 80353, UnitID = "player"},
				--心灵之歌
				{AuraID =  74224, UnitID = "player"},
				--上古狂乱
				{AuraID = 90355, UnitID = "player"},
				--闪电之盾
				{AuraID =   324, UnitID = "player"},
				--水之护盾
				{AuraID = 52127, UnitID = "player"},
				--潮汐奔涌
				{AuraID = 53390, UnitID = "player"},
				--5层漩涡武器
				{AuraID = 53817, UnitID = "player", Stack = 4},
				--大地之盾
				{AuraID = 974, UnitID = "player"},
				--激流
				{AuraID = 61295, UnitID = "player"},
				--火焰释放(火舌武器释放元素能量)
				{AuraID = 73683, UnitID = "player"},
				--灵魂行者的恩赐
				{AuraID = 79206, UnitID = "player"},
				--元素掌握
				{AuraID = 16166, UnitID = "player"},
				--萨满之怒
				{AuraID = 30823, UnitID = "player"},
				--大地生命武器(释放元素能量)
				{AuraID = 73685, UnitID = "player"},
				--自然迅捷
				{AuraID = 16188, UnitID = "player"},
				--节能施法
				{AuraID = 12536, UnitID = "player"},
				--幽魂之狼
				{AuraID = 2645, UnitID = "player"},
				--狂暴(巨魔种族天赋)
				{AuraID = 26297, UnitID = "player"},
			},
		},

		{	--左边自身的debuff
			Name = "Player_Debuff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 100},
			List = {
				--变羊
				{AuraID =   118, UnitID = "player"},
				--制裁之锤
				{AuraID =   853, UnitID = "player"},
				--肾击
				{AuraID =   408, UnitID = "player"},
				--撕扯
				{AuraID = 47481, UnitID = "player"},
				--沉默
				{AuraID = 55021, UnitID = "player"},
				--割碎
				{AuraID = 22570, UnitID = "player"},
				--断筋
				{AuraID =  1715, UnitID = "player"},
				--减速药膏
				{AuraID =  3775, UnitID = "player"},
				--烈焰震击
				{AuraID =  8050, UnitID = "player", Caster = "player"},
				--冰霜震击
				{AuraID =  8056, UnitID = "player", Caster = "player"},
				--大地震击
				{AuraID =  8042, UnitID = "player", Caster = "player"},
				--进化(黑石岩窟，柯尔拉·暮光之兆)
				{AuraID =  87378, UnitID = "player"},
				--暗影牢笼(黑石岩窟小怪，移动叠加伤害)
				{AuraID =  76686, UnitID = "player"},
				--寒冰炸弹(黑石岩窟小怪，每秒1000伤害降低35%移动速度)
				{AuraID =  76682, UnitID = "player"},
				--黑暗模拟
				{AuraID =  77606, UnitID = "player"},
				--SS恐惧
				{AuraID =  5782 ,UnitID = "focus"},
				--放逐术
				{AuraID =  710 ,UnitID = "focus"},
			},
		},

		{	--右边目标的buff
			Name = "Target_Buff_Icon",
			Direction = "RIGHT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", 135, 50},
			List = {	
				--先祖坚韧(-受到物理伤害10%)
				{AuraID =  16236, UnitID = "target"},	
				--大地生命
				{AuraID =  51945, UnitID = "target", Caster = "player"},	
				--大地之盾
				{AuraID =  974, UnitID = "target"},	
				--激流
				{AuraID =  61295, UnitID = "target", Caster = "player"},	
				--守护圣灵
				{AuraID =  47788, UnitID = "target"},				
				--痛苦压制
				{AuraID =  33206, UnitID = "target"},		
				--渐隐
				{AuraID =  586, UnitID = "target"},				
				--防恐结界
				{AuraID =  6346, UnitID = "target"},	
				--能量灌注
				{AuraID =  10060, UnitID = "target"},
				--嗜血
				{AuraID =  2825, UnitID = "target"},
				--英勇气概
				{AuraID = 32182, UnitID = "target"},
				--消散
				{AuraID = 47585, UnitID = "target"},		
				--时间扭曲
				{AuraID = 80353, UnitID = "target"},
				--真言术:障
				{AuraID = 81782, UnitID = "target"},
				--救赎之魂
				{AuraID = 20711, UnitID = "target"},
				--激活
				{AuraID = 29166, UnitID = "target"},
				--法术反射(盾反)
				{AuraID = 23920, UnitID = "target"},
				--寒冰屏障(冰箱)
				{AuraID = 45438, UnitID = "target"},
				--暗影斗篷
				{AuraID = 31224, UnitID = "target"},
				--圣盾术(无敌)
				{AuraID = 642, UnitID = "target"},
				--威慑
				{AuraID = 19263, UnitID = "target"},
				--反魔法护罩
				{AuraID = 48707, UnitID = "target"},
				--巫妖之躯
				{AuraID = 49039, UnitID = "target"},
				--根基图腾
				{AuraID = 8178, UnitID = "target"},
				--保护
				{AuraID = 1022, UnitID = "target"},
				--自由
				{AuraID = 1044, UnitID = "target"},
				--牺牲
				{AuraID = 6940, UnitID = "target"},
			},
		},			
		
		{	--右边目标的debuff
			Name = "Target_Debuff_Icon",
			Direction = "RIGHT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", 135, 90},
			List = {
				--灼热烈焰(灼热图腾)
				{AuraID = 77661, UnitID = "target", Caster = "player"},
				--烈焰震击
				--{AuraID =  8050, UnitID = "target", Caster = "player"},
				--大地震击
				{AuraID =  8042, UnitID = "target", Caster = "player"},
				--冰霜震击
				{AuraID =  8056, UnitID = "target", Caster = "player"},
				--妖术
				--{AuraID =  51514, UnitID = "target"},
				--束缚元素
				{AuraID =  76780, UnitID = "target"},
				--精神控制
				{AuraID = 605, UnitID = "target"},
				--羊
				{AuraID = 118, UnitID = "target"},
				--制裁
				{AuraID = 853, UnitID = "target"},
				--肾击
				{AuraID = 408, UnitID = "target"},
				--沉默
				{AuraID = 55021, UnitID = "target"},
				--断筋
				{AuraID = 1715, UnitID = "target"},
				--进化(黑石岩窟，柯尔拉·暮光之兆)
				{AuraID = 87378, UnitID = "target"},
				--暗影牢笼(黑石岩窟小怪，移动叠加伤害)
				{AuraID = 76686, UnitID = "target"},
				--寒冰炸弹(黑石岩窟小怪，每秒1000伤害降低35%移动速度)
				{AuraID = 76682, UnitID = "target"},
				--沉默
				{AuraID = 15487, UnitID = "target"},
				--减速膏药
				{AuraID = 3775, UnitID = "target"},
				--撕扯
				{AuraID = 47481, UnitID = "target"},
				--割碎
				{AuraID = 22570, UnitID = "target"},
				--黑暗模拟
				{AuraID = 77606, UnitID = "target"},
			},
		},

		{	--右边目标的条形debuff计时
			Name = "Target_Debuff_Bar",
			Direction = "UP",
			Interval = 8,
			Mode = "bar",
			IconSize = 30,
			BarWidth = 175,
			Pos = {"LEFT", UIParent, "CENTER", 150, 180},
			List = {
				--烈焰震击
				{AuraID =   8050, UnitID = "target", Caster = "player"},
				--束缚元素
				{AuraID =  76780, UnitID = "target", Caster = "player"},
				--妖术
				{AuraID = 51514, UnitID = "target", Caster = "player"},
			},
		},

		{	--焦点的条形debuff计时
			Name = "Focus_Debuff_Bar",
			Direction = "DOWN",
			Interval = 8,
			Mode = "bar",
			IconSize = 20,
			BarWidth = 175,
			Pos = {"CENTER", UIParent, "CENTER", -116, 250},
			List = {
				--束缚元素
				{AuraID =  76780, UnitID = "focus", Caster = "player"},
				--妖术
				{AuraID = 51514, UnitID = "focus", Caster = "player"},
			},
		},
--[[
		{	--左边的技能CD计时
			--Name = "CD",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 60},
			List = {	
				--熔岩猛击
				{SpellID = 60103, Filter = "CD"},
				--元素释放
				{SpellID = 73680, Filter = "CD"},
				--风暴打击
				{SpellID = 17364, Filter = "CD"},
				--大地震击
				{SpellID = 8042, Filter = "CD"},
				--妖术
				{SpellID = 51514, Filter = "CD"},
				--泰兰德的娃娃
				{SpellID = 64645, Filter = "CD"},
				--火焰新星
				{SpellID = 1535, Filter = "CD"},
				--野性狼魂
				{SpellID = 51533, Filter = "CD"},
				--灵魂行者的恩赐
				{SpellID = 79206, Filter = "CD"},
				--治疗之雨
				{SpellID = 73920, Filter = "CD"},
				--风剪
				{SpellID = 57994, Filter = "CD"},
				--闪电链
				{SpellID = 421, Filter = "CD"},
				--激流
				{SpellID = 61295, Filter = "CD"},
				--自然迅捷
				{SpellID = 16188, Filter = "CD"},
				--狂暴(巨魔种族天赋)
				{SpellID = 26297, Filter = "CD"},
				--灵魂连接图腾
				{SpellID = 98008, Filter = "CD"},
				--嗜血
				{SpellID = 2825, Filter = "CD"},
				--法力之潮图腾
				{SpellID = 16190, Filter = "CD"},
				--地缚图腾
				{SpellID = 2484, Filter = "CD"},
				--颤栗图腾
				{SpellID = 8143, Filter = "CD"},
				--土元素图腾
				{SpellID = 2062, Filter = "CD"},
				--火元素图腾
				{SpellID = 2894, Filter = "CD"},
				--石爪图腾
				{SpellID = 5730, Filter = "CD"},
				--根基图腾
				{SpellID = 8177, Filter = "CD"},
				--熔岩爆裂
				{SpellID = 51505, Filter = "CD"},
			},
		}, 
		]]
	},
	
	--圣骑士
	["PALADIN"] = {
		{	--左边自身的Buff
			Name = "Player_Buff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 50},
			List = {
				--至高能量
				{AuraID =  107948, UnitID = "player"},
				--战斗意念
				{AuraID =  109793, UnitID = "player"},
				--远古列王守卫
				{AuraID =  86698, UnitID = "player"},
				--狂热
				{AuraID =  85696, UnitID = "player"},
				--炽炎之能
				{AuraID =  99461, UnitID = "player"},
				--烈焰之翼
				{AuraID =  98619, UnitID = "player"},
				--生命之焰
				{AuraID =  99263, UnitID = "player"},
				--保护之手
				{AuraID =  1022, UnitID = "player"},
				--远古列王守卫
				{AuraID =  86150, UnitID = "player"},
				--光环掌握
				{AuraID =  31821, UnitID = "player"},
				--智者审判
				{AuraID =  31930, UnitID = "player"},
				--神圣使命
				{AuraID =  85433, UnitID = "player"},
				--神圣之盾
				{AuraID =  87342, UnitID = "player"},
				--清算
				{AuraID =  20177, UnitID = "player"},
				--自由之手
				{AuraID =  1044, UnitID = "player"},
				--牺牲之手
				{AuraID =  6940, UnitID = "player"},
				--圣光普照
				{AuraID =  82327, UnitID = "player"},
				--嗜血
				{AuraID =  2825, UnitID = "player"},
				--英勇气概
				{AuraID = 32182, UnitID = "player"},
				--圣佑术
				{AuraID =   498, UnitID = "player"},
				--圣盾术
				{AuraID =   642, UnitID = "player"},
				--神启
				{AuraID = 31842, UnitID = "player"},			
				--复仇之怒
				{AuraID = 31884, UnitID = "player"},
				--炙热防御者
				{AuraID = 31850, UnitID = "player"},
				--纯洁审判(等级3)
				{AuraID = 53657, UnitID = "player"},
				--圣光灌注
				{AuraID = 54149, UnitID = "player"},
				--神圣恳求
				{AuraID = 54428, UnitID = "player"},
				--战争艺术
				{AuraID = 59578, UnitID = "player"},
				--时间扭曲
				{AuraID = 80353, UnitID = "player"},
				--异端裁决
				{AuraID = 84963, UnitID = "player"},
				--黎明圣光
				{AuraID = 85222, UnitID = "player"},
				--狂热
				{AuraID = 85696, UnitID = "player"},
				--破晓
				{AuraID = 88819, UnitID = "player"},
				--神圣意志
				{AuraID = 90174, UnitID = "player"},
				--圣光道标
				{AuraID = 53563, UnitID = "player"},
				--纯洁审判
				{AuraID = 53657, UnitID = "player"},
			},
		},

		{	--左边自身的Debuff
			Name = "Player_Debuff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 90},
			List = {
				--变羊
				{AuraID =   118, UnitID = "player"},
				--制裁之锤
				{AuraID =   853, UnitID = "player"},
				--肾击
				{AuraID =   408, UnitID = "player"},
				--撕扯
				{AuraID = 47481, UnitID = "player"},
				--沉默
				{AuraID = 55021, UnitID = "player"},
				--割碎
				{AuraID = 22570, UnitID = "player"},
				--断筋
				{AuraID =  1715, UnitID = "player"},
				--减速药膏
				{AuraID =  3775, UnitID = "player"},
			},
		},
		
		{	--右边目标的Debuff(Buff)
			Name = "Target_Debuff_Icon",
			Direction = "RIGHT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", 135, 90},
			List = {
				--制裁之锤
				{AuraID = 853, UnitID = "target"},
				--神圣愤怒
				{AuraID =  2812, UnitID = "target"},
				--超度邪恶
				{AuraID = 10326, UnitID = "target"},
				--忏悔
				{AuraID = 20066, UnitID = "target"},
				--圣光道标
				{AuraID = 53563, UnitID = "target", Caster = "player"},
				--沉默
				{AuraID = 31935, UnitID = "target", Caster = "player"},
				--辩护
				{AuraID = 26017, UnitID = "target", Caster = "player"},
				--责罚
				{AuraID = 31803, UnitID = "target", Caster = "player"},
				--公正
				{AuraID = 20164, UnitID = "target", Caster = "player"},
			},
		},
		
		{	--焦点的条形debuff计时
			Name = "Focus_Debuff_Bar",
			Direction = "UP",
			Interval = 8,
			Mode = "bar",
			IconSize = 26,
			BarWidth = 175,
			Pos = {"CENTER", UIParent, "CENTER", -116, 250},
			List = {
				--制裁
				{AuraID =  853, UnitID = "focus", Caster = "player"},
				--道标
				{AuraID = 53563, UnitID = "focus", Caster = "player"},
			},
		},

	},

	--牧师
	["PRIEST"] = {
		{	--左边自身的buff
			Name = "Player_Buff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 50},
			List = {
				--世俗恩惠
				{AuraID =  105826, UnitID = "player"},
				--放缓流沙
				{AuraID =  109842, UnitID = "player"},
				--至高能量
				{AuraID =  107948, UnitID = "player"},
				--战斗意念
				{AuraID =  109793, UnitID = "player"},
				--心灵熔化
				{AuraID =  87160, UnitID = "player"},
				--提速
				{AuraID =  109787, UnitID = "player"},
				--暗黑之焰
				{AuraID =  99158, UnitID = "player"},
				--炽炎之能
				{AuraID =  99461, UnitID = "player"},
				--生命之焰
				{AuraID =  99263, UnitID = "player"},
				--烈焰之翼
				{AuraID =  98619, UnitID = "player"},
				--剧毒折磨(ZG毒锅)
				{AuraID =  96328, UnitID = "player"},
				--强效暗影
				{AuraID = 95799, UnitID = "player"},
				--黑暗天使长
				{AuraID = 87153, UnitID = "player"},
				--暗影宝珠
				{AuraID = 77487, UnitID = "player"},
				--嗜血
				{AuraID =  2825, UnitID = "player"},
				--英勇气概
				{AuraID = 32182, UnitID = "player"},
				--时间扭曲
				{AuraID = 80353, UnitID = "player"},
				--上古狂乱
				{AuraID = 90355, UnitID = "player"},	
				--能量灌注
				{AuraID =  10060, UnitID = "player"},
				--月亮井的祝福
				{AuraID =  100403, UnitID = "player"},
				--火焰精萃
				{AuraID =  97008, UnitID = "player"},
				--塞斯符文
				{AuraID =  97007, UnitID = "player"},				
				--防恐结界
				{AuraID =  6346, UnitID = "player"},
				--福音
				{AuraID = 81661, UnitID = "player"},
				--光之形兆
				{AuraID = 91192, UnitID = "player"},
				--消散
				{AuraID = 47585, UnitID = "player"},
				--真言术:障
				{AuraID = 81782, UnitID = "player"},
				--天使长
				{AuraID = 87152, UnitID = "player"},  
				--圣光涌动
				{AuraID = 88690, UnitID = "player"},
				--渐隐
				{AuraID =  586, UnitID = "player"},
				--火山毁灭(暗月卡片：火山)
				{AuraID =  89091, UnitID = "player"},	
				--火山药水
				{AuraID =  79476, UnitID = "player"},				
				--能量洪流(武器FM)
				{AuraID =  74241, UnitID = "player"},
				--亮纹刺绣
				{AuraID =  75170, UnitID = "player"},	
				--飓风(主手武器FM)
				{AuraID =  74211, UnitID = "player"},		
				--希望圣歌(提高法力值上限)
				{AuraID =  64904, UnitID = "player"},	
				--黑暗福音
				{AuraID = 87118, UnitID = "player"},
				--神圣庇护
				{AuraID = 75173, UnitID = "player"},				
				--神圣庇护
				{AuraID = 47515, UnitID = "player"},
				--恩赐
				{AuraID = 77613, UnitID = "player"},		
				--愈合祷言
				{AuraID =  33076, UnitID = "player"},				
				--守护圣灵
				{AuraID =  47788, UnitID = "player"},				
				--痛苦压制
				{AuraID =  33206, UnitID = "player"},				
				--真言术：盾
				{AuraID =  17, UnitID = "player"},				
				--恢复(Hot)
				{AuraID =  139, UnitID = "player"},					
				--灵魂之力(勇气SP)
				{AuraID =  91019, UnitID = "player"},
				--心灵之歌(治疗主手FM)
				{AuraID =  74224, UnitID = "player"},
				--灵魂之力(戒律天赋，和勇气SP触发的buff名称一样)
				{AuraID =  96267, UnitID = "player"},
				--心灵专注
				{AuraID =  89485, UnitID = "player"},
				--光明之泉恢复
				{AuraID =  7001, UnitID = "player"},
				--争分夺秒
				{AuraID = 59888, UnitID = "player"},			
				--妙手回春
				{AuraID = 63735, UnitID = "player"},
				--心灵融化
				{AuraID = 73510, UnitID = "player"},
				--脉轮:佑
				--{AuraID = 81206, UnitID = "player"},
				--脉轮:静
				--{AuraID = 81208, UnitID = "player"},
				--脉轮:罚
				--{AuraID = 81209, UnitID = "player"},
			},
		},

		{	--左边自身的debuff
			Name = "Player_Debuff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 90},
			List = {
				--虚弱灵魂
				{AuraID =  6788, UnitID = "player"},
				--心灵尖啸
				{AuraID =  8122, UnitID = "player"},
				--暗言术：痛
				{AuraID =  589, UnitID = "player"},
				--噬灵疫病
				{AuraID =  2944, UnitID = "player"},
				--吸血鬼之触
				{AuraID =  34914, UnitID = "player"},
				--进化(黑石岩窟，柯尔拉·暮光之兆)
				{AuraID =  87378, UnitID = "player"},
				--暗影牢笼(黑石岩窟小怪，移动叠加伤害)
				{AuraID =  76686, UnitID = "player"},
				--寒冰炸弹(黑石岩窟小怪，每秒1000伤害降低35%移动速度)
				{AuraID =  76682, UnitID = "player"},
				--变羊
				{AuraID =   118, UnitID = "player"},
				--制裁之锤
				{AuraID =   853, UnitID = "player"},
				--肾击
				{AuraID =   408, UnitID = "player"},
				--撕扯
				{AuraID = 47481, UnitID = "player"},
				--沉默
				{AuraID = 55021, UnitID = "player"},
				--割碎
				{AuraID = 22570, UnitID = "player"},
				--断筋
				{AuraID =  1715, UnitID = "player"},
				--减速药膏
				{AuraID =  3775, UnitID = "player"},
				--沉默
				{AuraID =  15487, UnitID = "player"},
				--黑暗模拟
				{AuraID =  77606, UnitID = "player"},
				--SS恐惧
				{AuraID =  5782 ,UnitID = "focus"},
				--放逐术
				{AuraID =  710 ,UnitID = "focus"},
				
			},
		},

		{	--右边目标的buff
			Name = "Target_Buff_Icon",
			Direction = "RIGHT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", 135, 50},
			List = {	
				--英勇气概
				{AuraID = 32182, UnitID = "target"},
				--时间扭曲
				{AuraID = 80353, UnitID = "target"},
				--嗜血
				{AuraID =  2825, UnitID = "target"},	
				--真言术:障
				{AuraID = 81782, UnitID = "target"},			
				--防恐结界
				{AuraID =  6346, UnitID = "target"},
				--愈合祷言
				{AuraID =  33076, UnitID = "target", Caster = "player"},				
				--守护圣灵
				{AuraID =  47788, UnitID = "target"},				
				--痛苦压制
				{AuraID =  33206, UnitID = "target", Caster = "player"},
				--激活
				{AuraID = 29166, UnitID = "target"},
				--法术反射(盾反)
				{AuraID = 23920, UnitID = "target"},
				--寒冰屏障(冰箱)
				{AuraID = 45438, UnitID = "target"},
				--暗影斗篷
				{AuraID = 31224, UnitID = "target"},
				--圣盾术(无敌)
				{AuraID = 642, UnitID = "target"},
				--威慑
				{AuraID = 19263, UnitID = "target"},
				--反魔法护罩
				{AuraID = 48707, UnitID = "target"},
				--巫妖之躯
				{AuraID = 49039, UnitID = "target"},
				--根基图腾
				{AuraID = 8178, UnitID = "target"},
				--保护
				{AuraID = 1022, UnitID = "target"},
				--自由
				{AuraID = 1044, UnitID = "target"},
				--牺牲
				{AuraID = 6940, UnitID = "target"},		
				--能量灌注
				{AuraID =  10060, UnitID = "target"},
				--灵魂之力
				{AuraID =  96267, UnitID = "target"},
				--消散
				{AuraID = 47585, UnitID = "target"},	
				--真言术：盾
				{AuraID =  17, UnitID = "target", Caster = "player"},			
				--恢复(Hot)
				{AuraID =  139, UnitID = "target", Caster = "player"},	
				--光明之泉恢复
				{AuraID =  7001, UnitID = "target", Caster = "player"},	
				--神圣庇护
				{AuraID =  47515, UnitID = "target", Caster = "player"},	
				--灵感
				{AuraID =  15357, UnitID = "target", Caster = "player"},					
				--渐隐
				{AuraID =  586, UnitID = "target"},			
				--妙手回春
				{AuraID = 63735, UnitID = "target"},
				--心灵融化
				{AuraID = 73510, UnitID = "target"},
				--天使长
				{AuraID = 87152, UnitID = "target"},
				--黑暗天使长
				{AuraID = 87153, UnitID = "target"},    
				--福音传播
				{AuraID = 81661, UnitID = "target"},
				--恩赐
				--{AuraID = 77613, UnitID = "target"},
				--福音传播
				{AuraID = 81661, UnitID = "target"},
				--救赎之魂
				{AuraID = 20711, UnitID = "target"},
			},
		},			

		{	--右边目标的debuff
			Name = "Target_Debuff_Icon",
			Direction = "RIGHT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", 135, 90},
			List = {
				--暗言术:痛
				--{AuraID =   589, UnitID = "target", Caster = "player"},
				--噬灵疫病
				--{AuraID =  2944, UnitID = "target", Caster = "player"},
				--虚弱灵魂
				{AuraID =  6788, UnitID = "target"},
				--吸血鬼之触
				--{AuraID = 34914, UnitID = "target", Caster = "player"},
				--束缚亡灵
				--{AuraID = 9484, UnitID = "target"},
				--心灵尖啸
				{AuraID = 8122, UnitID = "target"},
				--心灵尖刺
				{AuraID = 87178, UnitID = "target", Caster = "player"},
				--精神控制
				{AuraID = 605, UnitID = "target", Caster = "player"},
				--羊
				{AuraID = 118, UnitID = "target"},
				--制裁
				{AuraID = 853, UnitID = "target"},
				--肾击
				{AuraID = 408, UnitID = "target"},
				--沉默
				{AuraID = 55021, UnitID = "target"},
				--断筋
				{AuraID = 1715, UnitID = "target"},
				--进化(黑石岩窟，柯尔拉·暮光之兆)
				{AuraID = 87378, UnitID = "target"},
				--暗影牢笼(黑石岩窟小怪，移动叠加伤害)
				{AuraID = 76686, UnitID = "target"},
				--寒冰炸弹(黑石岩窟小怪，每秒1000伤害降低35%移动速度)
				{AuraID = 76682, UnitID = "target"},
				--沉默
				{AuraID = 15487, UnitID = "target"},
				--减速膏药
				{AuraID = 3775, UnitID = "target"},
				--撕扯
				{AuraID = 47481, UnitID = "target"},
				--割碎
				{AuraID = 22570, UnitID = "target"},
				--黑暗模拟
				{AuraID = 77606, UnitID = "target"},
			},
		},

		{	--右边目标的条形debuff计时
			Name = "Target_Debuff_Bar",
			Direction = "UP",
			Interval = 8,
			Mode = "bar",
			IconSize = 30,
			BarWidth = 175,
			Pos = {"LEFT", UIParent, "CENTER", 150, 150},
			List = {
				--暗言术:痛
				{AuraID =   589, UnitID = "target", Caster = "player"},
				--噬灵疫病
				{AuraID =  2944, UnitID = "target", Caster = "player"},
				--吸血鬼之触
				{AuraID = 34914, UnitID = "target", Caster = "player"},
				--束缚亡灵
				{AuraID = 9484, UnitID = "target"},
				--心灵尖啸
				--{AuraID = 8122, UnitID = "target"},
				--精神控制
				--{AuraID = 605, UnitID = "target"},
				--守护之魂
				{AuraID = 47788, UnitID = "target"},
				--痛苦压制
				--{AuraID = 33206, UnitID = "target"},
				--能量灌注
				--{AuraID = 10060, UnitID = "target"},
				--心灵惊骇
				--{AuraID = 64044, UnitID = "target"},
			},
		},

		{	--焦点的条形debuff计时
			Name = "Focus_Debuff_Bar",
			Direction = "DOWN",
			Interval = 6,
			Mode = "bar",
			IconSize = 20,
			BarWidth = 175,
			Pos = {"CENTER", UIParent, "CENTER", -116, 250},
			List = {
				--精神控制
				{AuraID =  605, UnitID = "focus", Caster = "player"},
				--束缚亡灵
				{AuraID = 9484, UnitID = "focus", Caster = "player"},
			},
		},

		--[[{	--物品CD监视(不支持内置CD)
			Name = "CD",
			Direction = "RIGHT",
			Interval = 4,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "BOTTOM", -275, 115},
			List = {	
				-- 随身邮箱
				{ItemID = 58183, Filter = "CD"},
				-- 达拉然戒指
				{ItemID = 51557, Filter = "CD"},
				-- 卡莱莎坠饰
				{ItemID = 68806, Filter = "CD"},
			}
		},
		
		{	--左边的技能CD计时
			--Name = "CD",
			Direction = "LEFT",
			Interval = 4,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 60},
			List = {	
				--苦修
				{SpellID = 47540, Filter = "CD"},
			},
		},]]
	},

	--术士
	["WARLOCK"] = {
		{	--左边自身的Buff
			Name = "Player_Buff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 50},
			List = {
				--放缓流沙
				{AuraID =  109842, UnitID = "player"},
				--至高能量
				{AuraID =  107948, UnitID = "player"},
				--战斗意念
				{AuraID =  109793, UnitID = "player"},
				--时间废墟
				{AuraID =  105786, UnitID = "player"},
				--法网恢恢
				{AuraID =  87173, UnitID = "player"},
				--灵魂链接
				{AuraID =  25228, UnitID = "player"},
				--恶魔之魂：恶魔卫士
				{AuraID =  79462, UnitID = "player"},
				--提速
				{AuraID =  109787, UnitID = "player"},
				--邪恶的馈赠
				{AuraID =  102662, UnitID = "player"},
				--飓风
				{AuraID =  74221, UnitID = "player"},
				--灵魂之力
				{AuraID =  91019, UnitID = "player"},
				--恶魔重生
				{AuraID =  88448, UnitID = "player"},
				--根除
				{AuraID =  64371, UnitID = "player"},
				--恶魔之魂：地狱猎犬
				{AuraID =  79460, UnitID = "player"},
				--恶魔法阵
				{AuraID =  48018, UnitID = "player"},
				--灵魂燃烧
				{AuraID =  74434, UnitID = "player"},
				--恶魔变身
				{AuraID =  47241, UnitID = "player"},
				--献祭光环
				{AuraID =  50589, UnitID = "player"},
				--进化(黑石岩窟，柯尔拉·暮光之兆)
				{AuraID =  87378, UnitID = "player"},
				--暗影牢笼(黑石岩窟小怪，移动叠加伤害)
				{AuraID =  76686, UnitID = "player"},
				--寒冰炸弹(黑石岩窟小怪，每秒1000伤害降低35%移动速度)
				{AuraID =  76682, UnitID = "player"},
				--灭杀
				{AuraID =  63167, UnitID = "player"},	
				--火山毁灭(暗月卡片：火山)
				{AuraID =  89091, UnitID = "player"},	
				--火山药水
				{AuraID =  79476, UnitID = "player"},				
				--能量洪流(武器FM)
				{AuraID =  74241, UnitID = "player"},
				--亮纹刺绣
				{AuraID =  75170, UnitID = "player"},	
				--飓风(主手武器FM)
				{AuraID =  74211, UnitID = "player"},		
				--能量灌注
				{AuraID =  10060, UnitID = "player"},
				--月亮井的祝福
				{AuraID =  100403, UnitID = "player"},
				--火焰精萃
				{AuraID =  97008, UnitID = "player"},
				--塞斯符文
				{AuraID =  97007, UnitID = "player"},			
				--炽炎之能
				{AuraID =  99461, UnitID = "player"},
				--生命之焰
				{AuraID =  99263, UnitID = "player"},
				--烈焰之翼
				{AuraID =  98619, UnitID = "player"},
				--剧毒折磨(ZG毒锅)
				{AuraID =  96328, UnitID = "player"},
				--邪甲术
				{AuraID =  28176, UnitID = "player"},
				--炽炎之能
				{AuraID =  99461, UnitID = "player"},
				--烈焰之翼
				{AuraID =  98619, UnitID = "player"},
				--嗜血
				{AuraID =  2825, UnitID = "player"},
				--英勇气概
				{AuraID = 32182, UnitID = "player"},
				--时间扭曲
				{AuraID = 80353, UnitID = "player"},
				--上古狂乱
				{AuraID = 90355, UnitID = "player"},
				--夜幕(等级2)
				{AuraID = 18095, UnitID = "player"},
				--反冲(等级3)
				{AuraID = 34939, UnitID = "player"},
				--小鬼增效
				{AuraID = 47283, UnitID = "player"},			
				--灭杀(等级2)
				{AuraID = 63158, UnitID = "player"},
				--熔火之心
				{AuraID = 71165, UnitID = "player"},
				--强化灵魂之火
				{AuraID = 85383, UnitID = "player"},
				--魔能火花
				{AuraID = 89937, UnitID = "player"},
				--灵魂交换
				{AuraID = 86121, UnitID = "player"},
				--爆燃
				{AuraID = 54277, UnitID = "player"},
				--暗影冥思
				{AuraID = 17941, UnitID = "player"},
				--根除
				{AuraID = 47197, UnitID = "player"},
			},
		},

		{	--左边自身的Debuff
			Name = "Player_Debuff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 90},
			List = {
				--变羊
				{AuraID =   118, UnitID = "player"},
				--制裁之锤
				{AuraID =   853, UnitID = "player"},
				--肾击
				{AuraID =   408, UnitID = "player"},
				--撕扯
				{AuraID = 47481, UnitID = "player"},
				--沉默
				{AuraID = 55021, UnitID = "player"},
				--割碎
				{AuraID = 22570, UnitID = "player"},
				--断筋
				{AuraID =  1715, UnitID = "player"},
				--减速药膏
				{AuraID =  3775, UnitID = "player"},
			},
		},

		{	--右边目标的Debuff
			Name = "Target_Debuff_Icon",
			Direction = "RIGHT",
			Interval = 4,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", 135, 90},
			List = {
				--灾星：元素诅咒
				{AuraID =   86105, UnitID = "target"},
				--腐蚀之种
				{AuraID =   27243, UnitID = "target", Caster = "player"},
				--暗影烈焰
				{AuraID =   47960, UnitID = "target", Caster = "player"},
				--腐蚀术
				--{AuraID =   172, UnitID = "target", Caster = "player"},
				--献祭
				--{AuraID =   348, UnitID = "target", Caster = "player"},
				--末日灾祸
				--{AuraID =   603, UnitID = "target", Caster = "player"},
				--暗影箭
				{AuraID =   686, UnitID = "target", Caster = "player"},
				--痛苦灾祸
				--{AuraID =   980, UnitID = "target", Caster = "player"},
				--元素诅咒
				{AuraID =  1490, UnitID = "target", Caster = "player"},
				--烧尽
				{AuraID = 29722, UnitID = "target", Caster = "player"},
				--痛苦无常
				--{AuraID = 30108, UnitID = "target", Caster = "player"},
				--鬼影缠身
				{AuraID = 48181, UnitID = "target", Caster = "player"},
				--混乱之箭
				{AuraID = 50796, UnitID = "target", Caster = "player"},
				--浩劫灾祸
				{AuraID = 80240, UnitID = "target", Caster = "player"},
				--古尔丹邪咒
				{AuraID = 86000, UnitID = "target", Caster = "player"},
				--恐惧
				--{AuraID = 5782, UnitID = "target"},
				--语言诅咒
				{AuraID = 1714, UnitID = "target", Caster = "player"},
				--暗影之拥
				{AuraID = 32389, UnitID = "target", Caster = "player"},
				--放逐术
				--{AuraID = 710, UnitID = "target", Caster = "player"},
				--虚弱诅咒
				{AuraID = 702, UnitID = "target", Caster = "player"},
				--疲劳诅咒
				{AuraID = 18223, UnitID = "target", Caster = "player"},
			},
		},	

		{	--右边目标的条形debuff计时
			Name = "Target_Debuff_Bar",
			Direction = "UP",
			Interval = 8,
			Mode = "bar",
			IconSize = 30,
			BarWidth = 175,
			Pos = {"LEFT", UIParent, "CENTER", 150, 150},
			List = {
				--痛苦灾祸
				{AuraID = 980, UnitID = "target", Caster = "player"},
				--痛苦无常
				{AuraID = 30108, UnitID = "target", Caster = "player"},
				--末日灾祸
				{AuraID =   603, UnitID = "target", Caster = "player"},
				--献祭
				{AuraID =  348, UnitID = "target", Caster = "player"},
				--腐蚀术
				{AuraID = 172, UnitID = "target", Caster = "player"},
				--恐惧
				{AuraID = 5782, UnitID = "target"},
				--放逐术
				{AuraID = 710, UnitID = "target"},
			},
		},
		
		{   --焦点的条形计时
			Name = "TargetDebuff",
			Direction = "UP",
			Interval = 8,
			Mode = "BAR",
			IconSize = 26,
			BarWidth = 175 ,
			Pos = {"CENTER", UIParent, "CENTER", -116, 250},
			List = {
				--SS恐惧
				{AuraID =  5782 ,UnitID = "focus", Caster = "player"},
				--放逐术
				{AuraID =  710 ,UnitID = "focus", Caster = "player"},
			},
		},
	},
	
	--盗贼
	["ROGUE"] = {
		{	--左边自身的Buff
			Name = "Player_Buff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 50},
			List = {
				--时间诀窍
				{AuraID =  105864, UnitID = "player"},
				--矩阵回稳器
				{AuraID =  96977, UnitID = "player"},
				--山崩
				{AuraID =  74245, UnitID = "player"},
				--受难
				{AuraID =  109959, UnitID = "player"},
				--时光之箭
				{AuraID =  102659, UnitID = "player"},
				--敏锐大师
				{AuraID =  13877, UnitID = "player"},
				--敏锐大师
				{AuraID =  31665, UnitID = "player"},
				--炽炎之能
				{AuraID =  99461, UnitID = "player"},
				--烈焰之翼
				{AuraID =  98619, UnitID = "player"},
				--暗影之舞
				{AuraID =  51713, UnitID = "player"},
				--敏锐大师
				{AuraID =  31665, UnitID = "player"},
				--轻度洞悉
				{AuraID =  84745, UnitID = "player"},
				--中度洞悉
				{AuraID =  84746, UnitID = "player"},
				--深度洞悉
				{AuraID =  84747, UnitID = "player"},
				--嗜血
				{AuraID =  2825, UnitID = "player"},
				--英勇气概
				{AuraID = 32182, UnitID = "player"},
				--佯攻
				{AuraID =  1966, UnitID = "player"},
				--备战就绪
				{AuraID =  74001, UnitID = "player"},
				--切割
				--{AuraID =  5171, UnitID = "player"},
				--嫁祸诀窍
				{AuraID = 57934, UnitID = "player"},			
				--灭绝
				{AuraID = 58427, UnitID = "player"},
				--嫁祸诀窍
				{AuraID = 59628, UnitID = "player"},
				--时间扭曲
				{AuraID = 80353, UnitID = "player"},
				--致命冲动
				{AuraID = 84590, UnitID = "player"},
				--剑刃乱舞
				--{AuraID = 13877, UnitID = "player"},
				--冲动
				{AuraID = 13750, UnitID = "player"},
				--暗影斗篷
				{AuraID = 31224, UnitID = "player"},
				--疾跑
				{AuraID = 2983, UnitID = "player"},
				--闪避
				{AuraID = 5277, UnitID = "player"},
				--毒伤
				{AuraID = 32645, UnitID = "player"},
				--灭绝
				{AuraID = 58426, UnitID = "player"},
				--恢复
				--{AuraID = 73651, UnitID = "player"},
				--扭转局势
				{AuraID = 51627, UnitID = "player"},
				--上古狂乱
				{AuraID = 90355, UnitID = "player"},
			}
		},
		
		{	--左边自身的Debuff
			Name = "Player_Debuff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 90},
			List = {
				--变羊
				{AuraID =   118, UnitID = "player"},
				--制裁之锤
				{AuraID =   853, UnitID = "player"},
				--肾击
				{AuraID =   408, UnitID = "player"},
				--撕扯
				{AuraID = 47481, UnitID = "player"},
				--沉默
				{AuraID = 55021, UnitID = "player"},
				--割碎
				{AuraID = 22570, UnitID = "player"},
				--断筋
				{AuraID =  1715, UnitID = "player"},
				--减速药膏
				{AuraID =  3775, UnitID = "player"},
			}
		},
		
		{	--左边目标的条形buff计时
			Name = "Target_Debuff_Bar",
			Direction = "UP",
			Interval = 8,
			Mode = "bar",
			IconSize = 30,
			BarWidth = 175,
			Pos = {"LEFT", UIParent, "CENTER", -295, 110},
			List = {
				--割裂
				{AuraID =   5171, UnitID = "player", Caster = "player"},
				--割裂
				{AuraID =   73651, UnitID = "player", Caster = "player"},
			},
		},

		{	--右边目标的Debuff
			Name = "Target_Debuff_Icon",
			Direction = "RIGHT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", 135, 90},
			List = {
				--仇杀
				{AuraID =  79140, UnitID = "target", Caster = "player"},
				--洞悉弱点
				{AuraID =  91021, UnitID = "target", Caster = "player"},
				--出血
				--{AuraID =  16511, UnitID = "target", Caster = "player"},
				--锁喉
				{AuraID =  703, UnitID = "target", Caster = "player"},
				--要害打击
				{AuraID = 84617, UnitID = "target", Caster = "player"},
				--偷袭
				{AuraID = 1833, UnitID = "target", Caster = "player"},
				--肾击
				{AuraID = 408, UnitID = "target", Caster = "player"},
				--凿击
				{AuraID = 1776, UnitID = "target", Caster = "player"},
				--致盲
				--{AuraID = 2094, UnitID = "target", Caster = "player"},
				--拆卸
				{AuraID = 51722, UnitID = "target", Caster = "player"},
				--闷棍
				--{AuraID = 6770, UnitID = "target", Caster = "player"},
				--割裂
				--{AuraID = 1943, UnitID = "target", Caster = "player"},
				--破甲
				{AuraID = 8647, UnitID = "target", Caster = "player"},
				--减速膏药
				{AuraID = 3408, UnitID = "target", Caster = "player"},
				--麻痹药膏
				{AuraID = 5761, UnitID = "target", Caster = "player"},
				--致命膏药
				{AuraID = 2818, UnitID = "target", Caster = "player"},
				--致伤膏药
				{AuraID = 13218, UnitID = "target", Caster = "player"},
			}
		},
		{	--右边目标的条形debuff计时
			Name = "Target_Debuff_Bar",
			Direction = "UP",
			Interval = 8,
			Mode = "bar",
			IconSize = 30,
			BarWidth = 175,
			Pos = {"LEFT", UIParent, "CENTER", 150, 180},
			List = {
				--割裂
				{AuraID =   1943, UnitID = "target", Caster = "player"},
				--出血
				{AuraID =   16511, UnitID = "target", Caster = "player"},
				--闷棍
				{AuraID =  6770, UnitID = "target", Caster = "player"},
				--致盲
				{AuraID = 2094, UnitID = "target", Caster = "player"},
			},
		},

		{	--焦点的条形debuff计时
			Name = "Focus_Debuff_Bar",
			Direction = "DOWN",
			Interval = 8,
			Mode = "bar",
			IconSize = 20,
			BarWidth = 175,
			Pos = {"CENTER", UIParent, "CENTER", -116, 250},
			List = {
				--闷棍
				{AuraID =  6770, UnitID = "focus", Caster = "player"},
				--致盲
				{AuraID = 2094, UnitID = "focus", Caster = "player"},
			},
		},
	},
	
	--死骑
	["DEATHKNIGHT"] = {
		{
			--Name = "Player_Buff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 50},
			List = {	
				--炽炎之能
				{AuraID =  99461, UnitID = "player"},
				--烈焰之翼
				{AuraID =  98619, UnitID = "player"},
				--嗜血
				{AuraID =  2825, UnitID = "player"},
				--英勇气概
				{AuraID = 32182, UnitID = "player"},
				--利刃屏障(等级3)
				{AuraID = 64856, UnitID = "player"},
				--反魔法护罩
				{AuraID = 48707, UnitID = "player"},
				--冰封之韧
				{AuraID = 48792, UnitID = "player"},			
				--巫妖之躯
				{AuraID = 49039, UnitID = "player"},
				--白骨之盾
				{AuraID = 49222, UnitID = "player"},
				--杀戮机器
				{AuraID = 51124, UnitID = "player"},
				--灰烬冰川
				{AuraID = 53386, UnitID = "player"},
				--吸血鬼之血
				{AuraID = 55233, UnitID = "player"},
				--冰冻之雾
				{AuraID = 59052, UnitID = "player"},
				--时间扭曲
				{AuraID = 80353, UnitID = "player"},
				--赤色天灾
				{AuraID = 81141, UnitID = "player"},
				--大墓地的意志
				{AuraID = 81162, UnitID = "player"},
				--符文刃舞
				{AuraID = 81256, UnitID = "player"},
				--不洁之力 力量提高15%
				{AuraID = 53365, UnitID = "player"},
				--邪恶之力 力量提高180点。
				{AuraID = 67117, UnitID = "player"},
				--上古狂乱
				{AuraID = 90355, UnitID = "player"},
				--号角
				{AuraID = 57330, UnitID = "player"},
				--血脸
				{AuraID = 48263, UnitID = "player"},
				--邪脸
				{AuraID = 48265, UnitID = "player"},
			},
		},
		
		{	--左边自身的Debuff
			--Name = "Player_Debuff_Icon",
			Direction = "LEFT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", -135, 90},
			List = {				
				--变羊
				{AuraID =   118, UnitID = "player"},
				--制裁之锤
				{AuraID =   853, UnitID = "player"},
				--肾击
				{AuraID =   408, UnitID = "player"},
				--撕扯
				{AuraID = 47481, UnitID = "player"},
				--沉默
				{AuraID = 55021, UnitID = "player"},
				--割碎
				{AuraID = 22570, UnitID = "player"},
				--断筋
			    {AuraID =  1715, UnitID = "player"},
				--减速药膏
			    {AuraID =  3775, UnitID = "player"},
			},
		},
		
		{	--右边目标的Debuff
			--Name = "Target_Debuff_Icon",
			Direction = "RIGHT",
			Interval = 6,
			Mode = "ICON",
			IconSize = 30,
			Pos = {"CENTER", UIParent, "CENTER", 135, 90},
			List = {
				--血之疫病
				--{AuraID = 55078, UnitID = "target", Caster = "player"},
				--冰霜疫病
				--{AuraID = 55095, UnitID = "target", Caster = "player"},
				--邪恶虫群
				{AuraID = 49194, UnitID = "target", Caster = "player"},
				--召唤石像鬼
				{AuraID = 49206, UnitID = "target", Caster = "player"},
			},
		},
				{	--右边目标的条形debuff计时
			Name = "Target_Debuff_Bar",
			Direction = "UP",
			Interval = 8,
			Mode = "bar",
			IconSize = 30,
			BarWidth = 175,
			Pos = {"LEFT", UIParent, "CENTER", 150, 150},
			List = {
				--血之疫病
				{AuraID =   55078, UnitID = "target", Caster = "player"},
				--冰霜疫病
				{AuraID =  55095, UnitID = "target", Caster = "player"},
			},
		},
		
		--[[{
			--Name = "CD",
			Direction = "UP",
			Interval = 4,
			Mode = "BAR",
			IconSize = 16,
			BarWidth = 175,
			Pos = {"CENTER", UIParent, "CENTER", 0, 100},
			List = {	
				--Example
				{AuraID = 57330, Filter = "CD"},
			},
		},	
		
		{
			Name = "CD",
			Direction = "DOWN",
			Interval = 4,
			Mode = "ICON",
			IconSize = 48,
			BarWidth = 175,
			Pos = {"CENTER", UIParent, "CENTER", 0, 100},
			List = {	
				-- 随身邮箱
				{itemID = 40768, Filter = "CD"},
				-- 不灭药水
				{itemID = 40093, Filter = "CD"},
				-- 厚烬丝绷带
				{itemID = 53050, Filter = "CD"},
			}
		},
		]]
	
	},
}