﻿local addon, ns = ...
local cfg = ns.cfg
local init = ns.init
local panel = CreateFrame("Frame", nil, UIParent)

if cfg.Spec == true then
	local Stat = CreateFrame("Frame")
	Stat:EnableMouse(true)
	Stat:SetFrameStrata("HIGH")
	Stat:SetFrameLevel(3)
	 
	local Text = panel:CreateFontString(nil, "OVERLAY")
	Text:SetFont(unpack(cfg.Fonts))
	Text:SetPoint(unpack(cfg.SpecPoint))
	 
	local int = 1
	local function Update(self, t)
		if not GetPrimaryTalentTree() then
			Text:SetText(cfg.ColorClass and init.Colored.."No Talents" or "No Talents") 
		return end
		int = int - t
		if int < 0 then
			local tree1 = select(5,GetTalentTabInfo(1))
			local tree2 = select(5,GetTalentTabInfo(2))
			local tree3 = select(5,GetTalentTabInfo(3))
			--local primaryTree = GetPrimaryTalentTree()
			Text:SetText(cfg.ColorClass and init.Colored..tree1.."/"..tree2.."/"..tree3 or tree1.."/"..tree2.."/"..tree3)
			--Text:SetText(cfg.ColorClass and init.Colored..select(2,GetTalentTabInfo(primaryTree,false,false)) or select(2,GetTalentTabInfo(primaryTree,false,false)))
		end
	end

	local function Checktalentgroup(index)
		return GetPrimaryTalentTree(false,false,index)
	end

	local function OnEvent(self, event, ...)
		if event == "PLAYER_LOGIN" then
			self:UnregisterEvent("PLAYER_LOGIN")
		end

		-- Setup Talents Tooltip
		self:SetAllPoints(Text)

		self:SetScript("OnEnter", function(self)

				local c = GetActiveTalentGroup(false,false)
				local group1tree1 = select(5,GetTalentTabInfo(1,false,false,1))
				local group1tree2 = select(5,GetTalentTabInfo(2,false,false,1))
				local group1tree3 = select(5,GetTalentTabInfo(3,false,false,1))
				local majorTree1 = GetPrimaryTalentTree(false,false,1)
				local group2tree1 = select(5,GetTalentTabInfo(1,false,false,2))
				local group2tree2 = select(5,GetTalentTabInfo(2,false,false,2))
				local group2tree3 = select(5,GetTalentTabInfo(3,false,false,2))
				local majorTree2 = GetPrimaryTalentTree(false,false,2)

				GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 6)
				GameTooltip:ClearAllPoints()
				GameTooltip:SetPoint("BOTTOM", self, "TOP", 0, 1)
				GameTooltip:ClearLines()
				GameTooltip:AddLine(TALENTS_BUTTON,0,.6,1)
				GameTooltip:AddLine(" ")
				if GetNumTalentGroups() == 1 then
					GameTooltip:AddLine("|cff00FF00* |r" .. (GetPrimaryTalentTree() and select(2,GetTalentTabInfo(majorTree1)) or infoL["none"])..": "..init.Colored..group1tree1.."/"..group1tree2.."/"..group1tree3,1,1,1)
				else
					if Checktalentgroup(1) and Checktalentgroup(2) then  -- 主有副有
						GameTooltip:AddLine("|cff00FF00"..(c == 1 and "* " or "   ") .. "|r" .. select(2,GetTalentTabInfo(majorTree1))..": "..init.Colored..group1tree1.."/"..group1tree2.."/"..group1tree3,1,1,1)
						GameTooltip:AddLine("|cff00FF00"..(c == 2 and "* " or "   ") .. "|r" .. select(2,GetTalentTabInfo(majorTree2))..": "..init.Colored..group2tree1.."/"..group2tree2.."/"..group2tree3,1,1,1)
					elseif Checktalentgroup(1) and (not Checktalentgroup(2)) then -- 主有副无
						GameTooltip:AddLine("|cff00FF00"..(c == 1 and "* " or "   ") .. "|r" .. select(2,GetTalentTabInfo(majorTree1))..": "..init.Colored..group1tree1.."/"..group1tree2.."/"..group1tree3,1,1,1)
						GameTooltip:AddLine("|cff00FF00"..(c == 2 and "* " or "   ") .. "|r" .. infoL["none"]..": "..init.Colored..group2tree1.."/"..group2tree2.."/"..group2tree3,1,1,1)
					elseif not (Checktalentgroup(1) or Checktalentgroup(2)) then -- 主无副无
						GameTooltip:AddLine("|cff00FF00"..(c == 1 and "* " or "   ") .. "|r" .. infoL["none"]..": "..init.Colored..group1tree1.."/"..group1tree2.."/"..group1tree3,1,1,1)
						GameTooltip:AddLine("|cff00FF00"..(c == 2 and "* " or "   ") .. "|r" .. infoL["none"]..": "..init.Colored..group2tree1.."/"..group2tree2.."/"..group2tree3,1,1,1)
					else -- 主无副有
						GameTooltip:AddLine("|cff00FF00"..(c == 1 and "* " or "   ") .. "|r" .. infoL["none"]..": "..init.Colored..group1tree1.."/"..group1tree2.."/"..group1tree3,1,1,1)
						GameTooltip:AddLine("|cff00FF00"..(c == 2 and "* " or "   ") .. "|r" .. select(2,GetTalentTabInfo(majorTree2))..": "..init.Colored..group2tree1.."/"..group2tree2.."/"..group2tree3,1,1,1)
					end
				end
				GameTooltip:Show()
			end)
		
		self:SetScript("OnLeave", function() GameTooltip:Hide() end)
	end
	 
	Stat:RegisterEvent("PLAYER_LOGIN")
	Stat:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
	Stat:SetScript("OnEvent", OnEvent)
	Stat:SetScript("OnUpdate", Update)
	Stat:SetScript("OnMouseDown", function(_,btn)
		if btn == "LeftButton" then
			ToggleTalentFrame()
		else
			c = GetActiveTalentGroup(false,false)
			SetActiveTalentGroup(c == 1 and 2 or 1)
		end
	end)
end
