﻿local addon, ns = ...
local cfg = CreateFrame("Frame")
local mediaFolder = "Interface\\AddOns\\oUF_Slim\\dMedia\\"	-- 别碰这里 ... 材质文件夹路径
local blankTex = "Interface\\Buttons\\WHITE8x8"

------------
-- colors -- 颜色
------------
	cfg.maincolor = {53/255, 69/255, 105/255}				-- 头像背景,团队血条,施法条颜色
	cfg.sndcolor = {255/255, 207/255, 164/255}				-- 字体颜色, ...
	cfg.trdcolor = {30/255, 30/255, 30/255}					-- 施法条颜色
	cfg.backdropcolor = {26/255, 25/255, 31/255}			-- 背景颜色	
	cfg.brdcolor = {0/255, 0/255, 0/255}					-- 边框颜色

	cfg.TransparencyMode = false						-- 启用/禁用 透明模式 - 透明化血条, 伴随 职业/反转染色的背景. 除了看起來漂亮, 对治疗来说也很友好.
	cfg.hpTransMcolor = {40/255, 40/255, 40/255}			-- 生命条颜色 - 仅限于透明模式
	cfg.hpTransMalpha = 0.4									-- 生命条透明度 - 仅限于透明模式
	
-----------	
-- media -- 材质
-----------
	cfg.HPtex = mediaFolder.."dM3"							-- 生命条材质
	cfg.PPtex = mediaFolder.."dM2"							-- 能量条材质
	cfg.CBtex = mediaFolder.."dM2"							-- 施法条材质
	cfg.Itex = blankTex										-- 背景材质
	cfg.Auratex = mediaFolder.."dBBorderL"					-- buff和debuff的边框材质

	cfg.NameFont = "Fonts\\fzcy.ttf"				        -- 姓名文字的字体
	cfg.NumbFont = "Fonts\\fzcy.ttf"					    -- 数字的字体
	cfg.NameFS = 13											-- 姓名字体大小
	cfg.NumbFS = 12 										-- 数字字体大小(比如能量值字体) (power value, etc.)
	cfg.hpNumbFS = 14										-- 生命值字体大小(玩家,目标,焦点) (player, target, focus)
	cfg.CastFS = 14											-- 施法条字体大小	
	cfg.ComboFS = 13										-- 连击点和职业点字体大小
	cfg.RaidFS = 12											-- 团队框体的aura或职业标签数字字体大小 (aura, class tags) on raid frames
	cfg.FontF = "THINOUTLINE"						-- "THINOUTLINE", "OUTLINE MONOCHROME", "OUTLINE" or nil (no outline) 4种选择
	cfg.fontFNum = "THINOUTLINE"							
	
----------------------
-- general settings -- 一般设置
----------------------	
	cfg.Numberzzz = 1						-- 0 将会把 18400 显示为 18k, 1 = 18.4k, ....
	cfg.FadeOutAlpha = 0.3 					-- 超出距离单位透明度 (oUF_SpellRange plugin, required)
	cfg.BarFadeAlpha = 0.2					-- oUF_BarFader 的透明度 (required) plugin (can be 0 - 1)
	
	-- switches -- true/false (on/off)
	cfg.useCastbar = true					-- 显示/隐藏 玩家,目标,焦点施法条
	cfg.useSpellIcon = true					-- 显示/隐藏 施法条图标
	cfg.showXpRep = false					-- 显示/隐藏 鼠标左键点击显示玩家的经验/声望
	cfg.delay = 1.5							-- 显示 经验/声望的延迟

	cfg.Castbarsafe = false 				-- 施法条延迟

	cfg.buSize = 20							-- 所有框架(除了团队)的aura大小
	cfg.buSizeRaid = 24						-- 团队框架的aura大小
	cfg.buHeightMulti = 1					-- aura的宽高比例 (1 = 正方形), 也许你会喜欢长方形 :p
	
------------
-- player -- 玩家
------------
	cfg.showDebuff = false					--玩家头像debuff显示
	cfg.PlayerRightSideSpellIcon = true		-- 把玩家的施法条图标从左边移动到右边
	
------------------------------------------------
-- class bar/points - Holy Power, Soul Shards, Runes -- 职业条/连击点/圣能/灵魂碎片/符文条
------------------------------------------------
	cfg.useClassPoints = false				-- 显示/隐藏 职业能力条(如牧师布道层数暗影宝珠层数，增强萨漩涡武器层数)
	cfg.ClassBarHeight = 4					-- DK符文条的高度以及萨满图腾条的高度(需要oUF_TotemBar組件)
	
------------
-- target -- 目标
------------
	cfg.totot = false						--目标的目标的目标
	cfg.TargetRightSideSpellIcon = false	-- 把目标的施法条图标从左边移动到右边
	
	cfg.onlyShowPlayerBuffs = false 		-- 只显示玩家施放的buffs(对目标和焦点生效) (target and focus)
	cfg.onlyShowPlayerDebuffs = false		-- 只显示玩家施放的debuffs(对目标和焦点生效) (target and focus)	
	
-----------
-- focus -- 焦点
-----------
	cfg.FocusRightSideSpellIcon = false		-- 焦点的施法条图标从左边移动到右边
	
-----------
-- party -- 小队
-----------
	cfg.PartyFrames = true -- 启用/禁用 小队框架
	
----------
-- raid -- 团队
----------
	cfg.RaidFrames = false	 				-- 启用/禁用 团队框架(队伍1-5)
	cfg.RaidFrames2 = false 				-- 启用/禁用 团队框架(队伍6-8)
	cfg.disableRaidFrameManager = true		-- 启用/禁用 blizzards团队管理
	cfg.RaidDebuffNumb = 2					-- 团队框架中可显示的debuff最大数量
	
-----------
-- arena -- 竞技场
----------- 
	cfg.ArenaFrames = true	 				-- 启用/禁用 竞技场框架
	
---------------
-- main tank -- 主坦克
---------------
	cfg.MTFrames = false	 					-- 启用/禁用 主坦克框架

----------
-- boss -- 
----------
	cfg.BossFrames = true	 				-- 启用/禁用 Boss框架	

-------------------
-- aura specific -- aura的特别设定
-------------------
	cfg.HideBlizzardAuras = false			-- 启用/禁用 oUF的玩家Aura
	cfg.HideAuraTimer = 180					-- 超过设定值则法术计时器显示较短的时间,否则隐藏
	cfg.FilterAuras = true					-- 通过提供一份白名单来过滤竞技场,小队和团队 Auras (白名单列表在Slim_AuraFilterList.lua中)
	
---------------	
-- framesize -- 框体大小
---------------
	-- 高度 height
	cfg.heightP = 14		-- 玩家 player
	cfg.heightT = 14		-- 目标 target
	cfg.heightF = 12		-- 焦点 Focus	
	cfg.heightS = 14 		-- 目标的目标, 焦点目标, 宠物 ToT, FocusTarget, pet
	cfg.heightM = 10 		-- 主坦克, Boss框体 MT, boss frames	
	cfg.heightPA = 11		-- 小队, 小队宠物 - 竞技场 party, party pet - arena
	cfg.heightR = 24		-- 团队 raid
	cfg.heightCB = 30		-- 职业条 class bar

	-- 宽度 width
	cfg.widthP = 225		-- 玩家 player
	cfg.widthT = 225		-- 目标 target
	cfg.widthF = 200		-- 焦点 Focus	
	cfg.widthM = 140 		-- 主坦克, Boss框体 MT, boss frames
	cfg.widthS = 46 		-- 目标的目标, 焦点目标, 宠物, 小队宠物 ToT, FocusTarget, pet, party pet
	cfg.widthPA = 200 		-- 小队 - 竞技场 party - arena
	cfg.widthR = 100 		-- 团队 raid
	cfg.widthCB = 30		-- 职业条 class bar
	
	-- hp|pp height, pp|info offset (optional)
	cfg.heightHP = 18		-- change frame height above, instead
	cfg.heightPP = 3.5		-- power height
	cfg.PPyOffset = 3.5		-- power y-Offset, can be a positiv/negative (down/up) value
	
--------------------------------	
-- oUF_WeaponEnchant settings -- oUF武器附魔模块oUF_WeaponEnchant设置
--------------------------------
	cfg.WeapEnchantIconSize	= 30			-- 武器附魔图标大小(需oUF_WeaponEnchant) oUF_WeaponEnchant icon size

	

----------------
--Combat Fader-- 战斗/无目标渐隐
----------------
cfg.combatfader = false 	--(内存无限制增加，慎启用)
cfg.TP = 0.15 				--渐隐透明度

--------------------------------
ns.cfg = cfg	-- 别碰这里 ...